#ifndef _COMCLASS_H
#define _COMCLASS_H
// (C) Copyright 1993 by Heiko Damerow MPG AG "Rntgenbeugung"
// File comclass.h

// Parameter-Codes
#define   	ON                  TRUE
#define   	OFF                 FALSE
#define   	W_ImageWindow       250
#define   	W_DiffractionWindow 251
#define   	W_PSDWindow         252
#define   	W_CounterWindow     253
#define   	W_EditWindow        254
#define   	W_AdjustmentWindow  255
#define   	W_OffLineWindow  		256


#define   	I_Position          280
#define   	I_Intensity         281
#define   	I_Report            282
// Voreinstellungen
#define   	LEFT                55
#define   	RIGHT               56
#define   	CONTROL             0x02
#define   	NOCONTROL           0xFD
#define   	ECHO                0x04
#define   	NOECHO              0xFB
#define   	MAXERROR            10

#define 		LenAdditionalInfo 	40

 extern "C" {
LRESULT CALLBACK 	_export WndProc						(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK 	_export FrameWndProc			(HWND,UINT,WPARAM,LPARAM);
}

#define MainWindow_Style WS_CLIPCHILDREN | WS_OVERLAPPED |  \
												 WS_CAPTION | WS_THICKFRAME |       \
												 WS_MINIMIZEBOX | WS_MAXIMIZEBOX |  \
												 WS_SYSMENU

#define ClientWindow_Style WS_CHILD | WS_CLIPCHILDREN | WS_VSCROLL | WS_HSCROLL
typedef struct
	{
	short       nFontType;
	LOGFONT     lf;
	TEXTMETRIC  tm;
	} T_Font;

class __rtti TMDIWindow
	{
	friend void    NewWindow(TMDIWindow*);
	friend LRESULT DoCommandsChild				(TMDIWindow *,HWND,WPARAM,LPARAM);
	friend LRESULT CALLBACK FrameWndProc	(HWND,UINT,WPARAM,LPARAM);
	friend LRESULT CALLBACK WndProc				(HWND,UINT,WPARAM,LPARAM);
	friend LRESULT CALLBACK AdjustmentProc(HWND,UINT,WPARAM,LPARAM);

	public:         TMDIWindow(void);
	virtual         ~TMDIWindow(void);
	HWND            GetWndHandle(void)        			{return hWndChild;};
	virtual void    CalibratePsd(void)        			{};
	virtual void    ExternSychronized(void)   			{};
	virtual LRESULT CallLocalAction(WPARAM,LPARAM)  {return 0l;};
	virtual void    MouseMove(WPARAM,LPARAM)  			{};
	virtual BOOL    SetTitle()                			{return TRUE;};
	virtual void    rButtonDown(LONG)         			{};
	virtual void    Paint(HDC,PAINTSTRUCT *)  			{};
	virtual void    RenderFormat(WPARAM)      			{};
	virtual void    RenderAllFormats(WPARAM)  			{};
	virtual void    SetFocus(void);
	virtual HCURSOR GetCursor(void) 			    			{return LoadCursor(NULL,IDC_ARROW);};
	// Virtuelle Funktionen zum Abwickeln von Ablufen
	// call via messages
	virtual void    SteeringReady(LPARAM)     			{};
	virtual void    SetRanges(void)           			{};
	virtual void    CounterSetRequest(LPARAM) 			{};
	virtual void    DistanceSetRequest(LPARAM)			{};
	virtual	void		PickUpData(LPARAM)        			{};
	virtual	void		SetKSProperties(TKSProperties*) {};
	// call via menu
	virtual void    InitializeTask(WPARAM,LPARAM) 	{};
	virtual void    InitializeDlg(WPARAM,LPARAM)  	{};
	virtual void    FreezeCurve(void)         			{};
	virtual void    KillSecondCurve(void)     			{};
	virtual void    SaveSecondCurve(void)     			{};
	BOOL            SetFileName(LPSTR);
	LPSTR						GetFileName(void)								{return FileName;};

	// call via system
	virtual BOOL    SaveFile(int);
	virtual BOOL    New(void);
	virtual BOOL    SaveFileAs(void);
	virtual void    TimerRequest(WPARAM)      			{};
	virtual BOOL    LoadOldData(int)          			{return FALSE;};
	virtual BOOL    UpdateFile(void)          			{return FALSE;};
	virtual void    Create(HWND hwnd)         			{hWndChild = hwnd;};
	virtual void    Size(HWND,WPARAM,LPARAM)  			{};
	void            UpdateMenu(void);
	void            UpdateWnd(int act);
	BOOL            WholeWnd(void);
	char						szDataPath[MaxString];

	protected:
	virtual BOOL    CanClose(void);
	virtual LPCSTR  ClassName(void)           			{return "Nutzerfenster";};
	virtual LPCSTR  GetCharacteristic(void)   			{return "Fenster";};
	virtual void    lButtonDown(WPARAM,LPARAM)			{};
	virtual void    DoCopy(void)              			{};
	virtual void    lButtonUp(WPARAM,LPARAM)  			{};
	virtual void    Interrupt(void);
	virtual BOOL    CanOpen(void);
	void            SetMenu(void);
	BOOL            IsModified(void)          			{return bFileChanged;};
	void            FileChange(void)          			{bFileChanged = TRUE;};
	WORD            RegisterWnd(void);
	void            GetWindowClass(WNDCLASS *wndClass);
	char            FileName[2*MaxString];
	char						szFilter[MaxString];
	char						szExtension[4];
	BOOL            bOldDataLoaded;
	BOOL            bIsNewFile;
	BOOL            bFileChanged;
	HWND            hWndChild;                		// Fenster-Handle des  Arbeitsfensters
	char            Title[MaxString];         		// headline
	char            FontName[MaxString];
	int             WindowType;
	RECT            WndRect;
	RECT            ClientRect;
	BOOL            bMeasurementActive;
	BOOL            bInterrupted;
	HMENU           TheMenu;                  // Lokales Menu des Fensters

	private:
	BOOL            bPaintPoint;
	static int      WindowId;                 // Fenster-Zhler
	};

typedef struct
	{
	HWND				hWndFrame;
	HWND				hWndClient;
	HINSTANCE 	hInstance;
	UINT        wm_DrawStatus;
	BOOL 		  	bCreateIniDefaults;
	char				IniFile[MAXPATH];
	} TMainParameters;

class TMain
	{
	public:       		TMain(void);
										~TMain(void);
	static int 				MessageLoop( void );
	void 							SetWatchIndicator(long);
	void 							SetParameters(void);
	void            	TellMessage(int);
	HMENU           	LoadMenuBar(void);
	BOOL            	GetVersion(LPSTR);
	TMainParameters*	GetParameters(void) {return &Parameters;};
	void            	LoadProfile(void);
	void							SaveProfile(void);
	void            	BlastStatusLine(HWND,HDC,int);
	void            	DrawStatus(HWND,ATOM,int);
	UINT            	wm_DrawStatus;
	BOOL							GetDataDlg(LPSTR,int*);
	TMDIWindow*     	CurrentWindow;
	TMDIWindow*       AdjustmentWindow;
	TMDIWindow*     	ScanWindow;
	TMDIWindow*     	CCDLineScanWindow;
	TMDIWindow*     	AreaScanWindow;
	HWND              hAdjustmentWindow;
	HWND              hCCDLineScanWindow;
	HWND            	hScanWindow;
	HWND            	hAreaScanWindow;
	HWND            	hActualWindow;
	int             	nStartup;
	HMENU           	hTheMenu;
	int             	CurrentID;
	HMENU           	CurrentPopup;
	char            	StatusInfo[2*MaxString];
	char							AdditionalInfo[LenAdditionalInfo];
	char            	Comment[2*MaxString];
	THKL           		Reflection;
	THKL			       	Orientation;
	char            	User[MaxString];
	char            	Target[MaxString];
	char            	TargetBulk[MaxString];
	float           	WaveLength;
	BOOL							bAutoCalibration;
	BOOL 		  				bCreateIniDefaults;
	int             	Voltage;
	int             	Current;
	HBITMAP         	bmpStatusLine;
	char							IFile[MAXPATH];
	char							szDirectory[MAXPATH];
	TMainParameters		Parameters;
	static HWND				hWndFrame;
	static HWND				hWndClient;
	static HINSTANCE 	hInstance;
	static HINSTANCE 	hPrevInstance;
	static HACCEL    	hAccellerator;
	static int 				nCmdShow;
	};

void  NewWindow(TMDIWindow*);
#endif
// _COMHEAD_H
// __LastLine__
