#include    "rc_def.h"
#include    "comhead.h"
#pragma hdrstop

#include "dlg_tpl.h"

// dlg_tpl.cpp
// (C) 1993,96 by Heiko Damerow
// Definition von Template Dialog-Prozeduren

TModalDlg*    TheDialog = NULL;
TModelessDlg* TheModeless = NULL;

extern HINSTANCE hModuleInstance;

//******************************************************************************
BOOL CALLBACK _export DialogProc(HWND hDlg,UINT msg,WPARAM wParam,LPARAM lParam)
	{
	BOOL bProcessed = TRUE;
	TheDialog->hWindow = hDlg;
	switch(msg){
		HANDLE_MSG(hDlg, WM_INITDIALOG,     TheDialog->Dlg_OnInit);
		HANDLE_MSG(hDlg, WM_COMMAND,        TheDialog->Dlg_OnCommand);
		HANDLE_MSG(hDlg, WM_HSCROLL,        TheDialog->Dlg_OnHScrollBar);
		HANDLE_MSG(hDlg, WM_VSCROLL,        TheDialog->Dlg_OnVScrollBar);
		HANDLE_MSG(hDlg, WM_TIMER,          TheDialog->Dlg_OnTimer);

		case WM_CHAR: // WM_KEYDOWN:
		if(wParam == VK_ESCAPE)
			// if(1 < (int)GET_WM_COMMAND_HWND(wParam,lParam))
			TheDialog->Interrupt();
		break;

		case WM_SYSCOLORCHANGE:
		Ctl3dColorChange();
		break;

		default:
		bProcessed = FALSE;
		}
	return bProcessed;
	};

int TModalDlg::ExecuteDialog(HWND hWindow)
	{
	TheDialog = this;
	return DialogBoxParam( hInstance,RC_Name,hWindow,
												(DLGPROC)dialogFunc,0l);
	};

TModalDlg::TModalDlg(char *DlgName)
	{
	if(TheDialog)
		{
		bCallUp = TRUE;
		dlgInstance = TheDialog;
		}
		else
		bCallUp = FALSE;
	hInstance = hModuleInstance;
	dialogFunc = MakeProcInstance((FARPROC)DialogProc,hInstance);
	strcpy(RC_Name,DlgName);
	};

TModalDlg::~TModalDlg()
	{
	FreeProcInstance(dialogFunc);
	if(bCallUp)
		TheDialog = dlgInstance;
	};

#pragma argsused
BOOL TModalDlg::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM)
	{
	hWindow = hwnd;
	return(TRUE);
	};

#pragma argsused
void TModalDlg::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
	{
	switch(id)
		{
		case IDOK:
		if(CanClose())
			{
			LeaveDialog();
			EndDialog(hwnd,id);
			}
		break;

		case IDCANCEL:
		LeaveDialog();
		EndDialog(hwnd,id);
		break;

		case IDABORT:
		LeaveDialog();
		EndDialog(hwnd,id);
		break;
		}
	};

BOOL TModalDlg::CanClose(void)
	{
	return TRUE;
	};
//##############################################################################
BOOL CALLBACK  _export ModelessProc(HWND hDlg,UINT msg,WPARAM wParam,LPARAM lParam)
	{
	BOOL bProcessed = TRUE;
	switch(msg){
		HANDLE_MSG(hDlg, WM_INITDIALOG,     TheModeless->Dlg_OnInit);
		HANDLE_MSG(hDlg, WM_COMMAND,        TheModeless->Dlg_OnCommand);
		HANDLE_MSG(hDlg, WM_HSCROLL,        TheModeless->Dlg_OnHScrollBar);
		HANDLE_MSG(hDlg, WM_VSCROLL,        TheModeless->Dlg_OnVScrollBar);
		HANDLE_MSG(hDlg, WM_LBUTTONUP,      TheModeless->Dlg_OnLButtonUp);
		HANDLE_MSG(hDlg, WM_MOUSEACTIVATE,  TheModeless->Dlg_OnMouseActivate);
		HANDLE_MSG(hDlg, WM_SETFOCUS,       TheModeless->Dlg_OnSetFocus);
		HANDLE_MSG(hDlg, WM_TIMER,          TheModeless->Dlg_OnTimer);

		case WM_SYSCOLORCHANGE:
		Ctl3dColorChange();
		break;

		case WM_CHAR: // WM_KEYDOWN:
		if(wParam == VK_ESCAPE)
			// if(1 < (int)GET_WM_COMMAND_HWND(wParam,lParam))
			TheModeless->Interrupt();
		break;

		default:
		bProcessed = FALSE;
		}
	return bProcessed;
	};

TModelessDlg::TModelessDlg(char *DlgName)
	{
	dialogFunc = (DLGPROC)MakeProcInstance((FARPROC)ModelessProc,GetMainInstance());
	strcpy(RC_Name,DlgName);
	};

TModelessDlg::~TModelessDlg(void)
	{
	DestroyWindow(hWindow);
	TheModeless = NULL;
	};

BOOL TModelessDlg::Initialize(void)
	{
	hWindow = CreateDialog(GetMainInstance(),RC_Name,GetFrameHandle(),ModelessProc);
	ShowWindow(hWindow,SW_SHOW);
	TheModeless = this;
	return TRUE;
	};

#pragma argsused
BOOL TModelessDlg::Dlg_OnInit(HWND hwnd, HWND hwndFocus, LPARAM lParam)
	{
	return TRUE;
	}

#pragma argsused
void TModelessDlg::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
	{
	switch(id)
		{
		case IDOK:
		if(CanClose())
			{
			LeaveDialog();
			delete TheModeless;
			}
		break;

		case IDCANCEL: case IDABORT:
		LeaveDialog();
		delete TheModeless;
		}
	};

BOOL TModelessDlg::CanClose(void)
	{
	return TRUE;
	};
// __LastLine__

