/*
    Function declarations for "C" and C++ to IEEE-488 interface routines.
    (C) 1989-1992, Capital Equipment Corp.
*/

/*
    function declarations
*/

#ifdef __cplusplus
  extern "C" {
#endif

void far pascal ieee488_initialize (int,int);
int far pascal ieee488_transmit (char far *,unsigned,int far *);
int far pascal ieee488_receive (char far *,unsigned,unsigned far *,int far *);
int far pascal ieee488_send (int,char far *,unsigned,int far *);
int far pascal ieee488_enter (char far *,unsigned,unsigned far *,int,int far *);
int far pascal ieee488_spoll (int,char far *,int far *);
void far pascal ieee488_ppoll (char far *);
int far pascal ieee488_tarray (void far *,unsigned,int,int far *);
int far pascal ieee488_rarray (void far *,unsigned,unsigned far *,int far *);

char far pascal ieee488_srq(void);

void far pascal ieee488_setport (int,unsigned);

void far pascal ieee488_boardselect (int);
void far pascal ieee488_dmachannel (int);
void far pascal ieee488_settimeout (unsigned);
void far pascal ieee488_setoutputEOS (int,int);
void far pascal ieee488_setinputEOS (int);

void far pascal ieee488_enable_488ex(int);
void far pascal ieee488_enable_488sd(int,int);
char far pascal ieee488_listener_present(int);
char far pascal ieee488_board_present(void);
#ifdef __cplusplus
 }
#endif

typedef void 	(WINAPI *TInitialize) 		(int,int);
typedef int 	(WINAPI *TSend)           (int,LPSTR,WORD,LPINT);
typedef int		(WINAPI *TEnter)          (LPSTR,WORD,LPWORD,int,LPINT);
typedef int		(WINAPI *TTransmit)       (LPSTR,WORD,LPINT);
typedef int		(WINAPI *TReceive)        (LPSTR,WORD,LPWORD,LPINT);
typedef int		(WINAPI *TSPoll)          (int,LPSTR,LPINT);
typedef void	(WINAPI *TPPoll)          (LPSTR);
typedef void	(WINAPI *TSetPort)        (int,WORD);
typedef void	(WINAPI *TSetTimeout)     (WORD);
typedef void	(WINAPI *TSetOutputEOS)   (int,int);
typedef void	(WINAPI *TSetInputEOS)    (int);
typedef void	(WINAPI *TEnable488Ex)    (int);
typedef void	(WINAPI *TEnable488SD)    (int,int);
typedef char	(WINAPI *TListenerOk)     (int);
typedef char	(WINAPI *TBoardPresent)   (void);

/*
		"define"s to modify user's calls into direct calls to 488 support code
*/

/*** handle bug in Turbo C 3.0 handling of DOS extenders ***/
#if defined(__TURBOC__) && (__TURBOC__ < 0x0410) && !defined(_Windows)
#ifdef __cplusplus
extern "C"
#endif
void far pascal ieee488_protcheck(int);
#define initialize(addr,level)          ieee488_protcheck(0); ieee488_initialize(addr,level)
#else
#define initialize(addr,level)          ieee488_initialize(addr,level)
#endif

#define transmit(cmd,status)            ieee488_transmit((char far *) (cmd),0xFFFF,(int far *) status)
#define receive(s,maxlen,len,status)    ieee488_receive((char far *) (s),maxlen,(unsigned int far *) len,(int far *) status)
#define send(addr,s,status)             ieee488_send(addr,(char far *) (s),0xFFFF,(int far *) status)
#define enter(s,maxlen,len,addr,status) ieee488_enter((char far *) (s),maxlen,(unsigned int far *) len,addr,(int far *) status)
#define spoll(addr,poll,status)         ieee488_spoll(addr,(char far *) poll,(int far *) status)
#define ppoll(poll)                     ieee488_ppoll((char far *) poll)
#define tarray(d,count,eoi,status)      ieee488_tarray((void far *) d,count,eoi,(int far *) status)
#define rarray(d,count,len,status)      ieee488_rarray((void far *) d,count,(unsigned int far *) len,(int far *) status)
#define srq                             ieee488_srq
#define setport(bd,io)                  ieee488_setport(bd,io)
#define boardselect(bd)                 ieee488_boardselect(bd)
#define dmachannel(c)                   ieee488_dmachannel(c)
#define settimeout(t)                   ieee488_settimeout(t)
#define setoutputEOS(e1,e2)             ieee488_setoutputEOS(e1,e2)
#define setinputEOS(e)                  ieee488_setinputEOS(e)
#define enable_488ex(e)                 ieee488_enable_488ex(e)
#define enable_488sd(e,t)               ieee488_enable_488sd(e,t)
#define listener_present(a)             ieee488_listener_present(a)
#define gpib_board_present              ieee488_board_present
// __LastLine__

