#include  "rc_def.h"
#include  "comhead.h"
#pragma hdrstop

// l_layer.cpp
// (C) 1993,1994 by Heiko Damerow MPG AG "Roentgenbeugung"
// Allgemeine Funktionen

TMainParameters			MainP;
int               	bModulLoaded = FALSE;
HANDLE 							hTheModule;
HINSTANCE         	hModuleInstance;
extern LPDataBase 	lpDataBase;

static  char        spVersion[] = "V 1.51 ("__DATE__")";


class TAbout : public TModalDlg
	{
	public:			 TAbout(void);
	private:
	BOOL         Dlg_OnInit(HWND,HWND,LPARAM);
	void         Dlg_OnCommand(HWND,int,HWND,UINT);
	BOOL         LeaveDialog(void) {return TRUE;};
	};

#ifdef __WIN32__
BOOL DllEntryPoint(HANDLE hModule,DWORD dwFunction,LPVOID)
	{
	switch (dwFunction)
		{
		case DLL_PROCESS_ATTACH:
		// Initialize function array.
		bModulLoaded = FALSE;
		hTheModule = hModule;
		lpDataBase = (LPDataBase)new TDataBase();
		break;
		};
	return TRUE;
	}

#else
int FAR PASCAL LibMain(HINSTANCE hInstance,WORD,WORD wHeapSize,LPSTR)
	{
	if(wHeapSize != 0)
		UnlockData(0);
	bModulLoaded = FALSE;
	hModuleInstance = hInstance;
	lpDataBase = (LPDataBase)new TDataBase();
	return 1;
	};

#pragma argsused
int CALLBACK WEP(int bSystemExit)
	{
	bModulLoaded = FALSE;
	return 1;
	};
#endif

LPCSTR  _export WINAPI spGetVersion(void)
	{
	return (LPCSTR)spVersion;
	};

HINSTANCE _export WINAPI spGetInstance(void)
	{
	return hModuleInstance;
	};

//******************************************************************************
//************** Autorisierungs-System *****************************************
//******************************************************************************
static	char AuthorAddress[] 	= "damerow@nz.dlr.de";
static	char WorkAddress[] 		= "Kalkhorstweg 53\n" \
																"17235 Neustrelitz\n" \
																"damerow@nz.dlr.de";
static	char AuthorName[]			= "Heiko Damerow";
static	char CoAuthorName[]		= "Heiko Brandhorst (Braun-Psd-Interface)";
/*
	Asa.DLL
		- Code knnte durch eigenen Code ersetzt werden

	Radicon-Zhler
	 - Code zur Ansteuerung der Radicon-Zhler
*/

void _export WINAPI AboutTheMaker(void)
	{
	TAbout* dlg = new TAbout();
	dlg->ExecuteDialog(GetFrameHandle());
	delete dlg;
	};

TAbout::TAbout() : TModalDlg("About")
	{
	};

BOOL TAbout::Dlg_OnInit(HWND hwnd,HWND hwndCtl,LPARAM)
	{
	char  HeadLine[MaxString];

	strcpy(HeadLine,"ber Steuerprogramm");
	SetWindowText(hwnd,HeadLine);
	SetDlgItemText(hwnd,cm_ShowAuthorName,AuthorName);
	SetDlgItemText(hwnd,cm_ShowCoAuthorName,CoAuthorName);
	TModalDlg::Dlg_OnInit(hwnd,hwndCtl,0l);
	return TRUE;
	};

void TAbout::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
	{
	switch(id)
		{
		case cm_ShowWorkAddress:
		MessageBox(GetFocus(),WorkAddress,"Adresse",MBINFO);
		break;

		case cm_ShowAuthorAddress:
		MessageBox(GetFocus(),AuthorAddress,"Adresse",MBINFO);
		break;

		default:
		TModalDlg::Dlg_OnCommand(hwnd,id,hwndCtl,codeNotify);
		}
	};

//******************************************************************************
//******************************************************************************
LPCSTR _export WINAPI GetCFile(void)
	{
	return (LPCSTR)MainP.IniFile;
	};

HWND _export WINAPI GetFrameHandle(void)
	{
	return MainP.hWndFrame;
	};

HWND _export WINAPI GetClientHandle(void)
	{
	return MainP.hWndClient;
	};

HINSTANCE _export WINAPI GetMainInstance(void)
	{
	return MainP.hInstance;
	};

LPDataBase _export WINAPI GetDataBasePtr(void)
	{
	if(!bModulLoaded) return NULL;
	return (LPDataBase)lpDataBase;
	};

BOOL _export WINAPI InitializeSPLibrary(TMainParameters* MainParam)
	{
	MainP = *MainParam;
	bModulLoaded = TRUE;
	return TRUE;
	};

TxScanType _export WINAPI ParsingXScanType(LPSTR xst)
	{
	if(!strcmp(xst,"Standard")) 			return StandardScan;
	if(!strcmp(xst,"Omega2Theta")) 		return Omega2ThetaScan;
	if(!strcmp(xst,"Continuous")) 		return ContinuousScan;
	if(!strcmp(xst,"PsdEnergyScan")) 	return PsdEnergyScan;
	if(!strcmp(xst,"PsdPositionScan"))return PsdPositionScan;
	if(!strcmp(xst,"Omega2ThetaList"))return Omega2ThetaScanList;
	if(!strcmp(xst,"ScanList")) 			return ScanList;
	return (TxScanType)0;
	};

BOOL _export WINAPI CreateDefaults(void)
	{
	return MainP.bCreateIniDefaults;
	};

void _export WINAPI SetInfo(LPCSTR status_txt)
	{
	ATOM        hAtom;

	hAtom = GlobalAddAtom(status_txt);
	if(hAtom)
		SendMessage(MainP.hWndFrame,MainP.wm_DrawStatus,1002,(LONG)hAtom);
	};

void _export WINAPI SetStaticInfo(LPCSTR status_txt)
	{
	ATOM        hAtom;

	hAtom = GlobalAddAtom(status_txt);
	if(hAtom)
		PostMessage(MainP.hWndFrame,MainP.wm_DrawStatus,1000,(LONG)hAtom);
	};


void _export WINAPI SetStatus(LPCSTR status_txt)
	{
	ATOM        hAtom;

	hAtom = GlobalAddAtom(status_txt);
	if(hAtom)
		PostMessage(MainP.hWndFrame,MainP.wm_DrawStatus,1001,(LONG)hAtom);
	};

BOOL _export WINAPI FileOpen(LPCSTR HeadLine,LPSTR szFilter,LPSTR szFileName,LPCSTR StartupPath)
	{
	OPENFILENAME 	ofnTemp;
	DWORD 				Errval; 	// Error value
	char 					buf[5];  	// Error buffer
	char 					Errstr[50]="GetOpenFileName returned Error #";
	char					chSeperator = '|';
	int						i;

	ofnTemp.lStructSize = sizeof(OPENFILENAME);
	ofnTemp.hwndOwner = MainP.hWndFrame; // An invalid hWnd causes non-modality
	ofnTemp.hInstance = 0;
	ofnTemp.lpstrFilter = (LPSTR)szFilter;  // See previous note concerning string
	ofnTemp.lpstrCustomFilter = (LPSTR)szFilter;
	ofnTemp.nMaxCustFilter = strlen(szFilter);
	ofnTemp.nFilterIndex = 1;
	ofnTemp.lpstrFile = (LPSTR)szFileName;  // Stores the result in this variable
	ofnTemp.nMaxFile = MAXPATH;
	ofnTemp.lpstrFileTitle = NULL;
	ofnTemp.nMaxFileTitle = 0;
	ofnTemp.lpstrInitialDir = StartupPath;
	ofnTemp.lpstrTitle = HeadLine;
	ofnTemp.Flags = OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST;
	ofnTemp.nFileOffset = 0;
	ofnTemp.nFileExtension = 0;
	ofnTemp.lpstrDefExt = NULL;
	ofnTemp.lCustData = NULL;
	ofnTemp.lpfnHook = NULL;
	ofnTemp.lpTemplateName = NULL;
	/*
	If the call to GetOpenFileName() fails you can call CommDlgExtendedError()
	to retrieve the type of error that occured.
	*/
	for(i = 0;szFilter[i] != '\0';i++)
		if(szFilter[i] == chSeperator)
			 szFilter[i] = '\0';
	if(!GetOpenFileName(&ofnTemp))
		{
		Errval = CommDlgExtendedError();
		if(Errval) // 0 value means user selected Cancel
			{
			sprintf(buf,"%ld",Errval);
			strcat(Errstr,buf);
			MessageBox(MainP.hWndFrame,Errstr,"WARNING",MB_OK|MB_ICONSTOP);
			}
		return FALSE;
		}
	InvalidateRect(MainP.hWndFrame, NULL, TRUE ); // Repaint to display the new name
	return TRUE;
	};

BOOL _export WINAPI FileSave(LPCSTR HeadLine,LPSTR szFilter,LPSTR szFileName,LPCSTR StartupPath)
	{
	OPENFILENAME 	ofnTemp;
	DWORD 				Errval; 	// Error value
	char 					buf[5];  	// Error buffer
	char 					Errstr[50] = "GetSaveFileName returned Error #";
	char					chSeperator = '|';
	int						i;

	ofnTemp.lStructSize = sizeof(OPENFILENAME);
	ofnTemp.hwndOwner = MainP.hWndFrame; // An invalid hWnd causes non-modality
	ofnTemp.hInstance = 0;
	ofnTemp.lpstrFilter = szFilter;  // See previous note concerning string
	ofnTemp.lpstrCustomFilter = (LPSTR)szFilter;
	ofnTemp.nMaxCustFilter = strlen(szFilter);
	ofnTemp.nFilterIndex = 1;
	ofnTemp.lpstrFile = (LPSTR)szFileName;  // Stores the result in this variable
	ofnTemp.nMaxFile = MAXPATH;
	ofnTemp.lpstrFileTitle = NULL;
	ofnTemp.nMaxFileTitle = 0;
	ofnTemp.lpstrInitialDir = StartupPath;
	ofnTemp.lpstrTitle = HeadLine;
	ofnTemp.Flags = OFN_HIDEREADONLY | OFN_READONLY | OFN_OVERWRITEPROMPT;
	ofnTemp.nFileOffset = 0;
	ofnTemp.nFileExtension = 0;
	ofnTemp.lpstrDefExt = NULL;
	ofnTemp.lCustData = NULL;
	ofnTemp.lpfnHook = NULL;
	ofnTemp.lpTemplateName = NULL;
	/*
	If the call to GetOpenFileName() fails you can call CommDlgExtendedError()
	to retrieve the type of error that occured.
	*/
	for(i = 0;szFilter[i] != '\0';i++)
		{
		if(szFilter[i] == chSeperator)
			 szFilter[i] = '\0';
		}
	if(!GetSaveFileName(&ofnTemp))
		{
		Errval = CommDlgExtendedError();
		if(Errval) // 0 value means user selected Cancel
			{
			sprintf(buf,"%ld",Errval);
			strcat(Errstr,buf);
			MessageBox(MainP.hWndFrame,Errstr,"WARNING",MB_OK|MB_ICONSTOP);
			}
		return FALSE;
		}
	InvalidateRect(MainP.hWndFrame,NULL,TRUE); // Repaint to display the new name
	return TRUE;
	};

BOOL _export WINAPI SetFPOnData(HFILE hfile)
	{
	char    data;
	char*   buf;
	BOOL	  EoH = FALSE;
	int     cnt,cntfp;

	// the file pointer will be set on the first character after
	// the key [Data] and any whitespaces (\r \n \t _)
	buf = new char[21];
	_llseek(hfile,0,0);
	cntfp = 0;
	while(_lread(hfile,&data,1))
		{
		cntfp++;
		if(data == '[')
			{
			cnt = 0;
			while(_lread(hfile,&data,1))
				{
				cntfp++;
				if(data == ']')
					{
					buf[cnt++] = 0;
					if(strstr(buf,"Data"))
						goto Finish;
						else
						goto SearchAgain;
					}
				buf[cnt++] = data;
				} // after break
			delete[] buf;
			return FALSE;
			}
SearchAgain:
		}
	delete[] buf;
	return FALSE;
Finish:
	while(_lread(hfile,&data,1))
		{
		if(data == ' ')   continue;
		if(data == '\r')  continue;
		if(data == '\n')  continue;
		if(data == '\t')  continue;
		_llseek(hfile,-1,1);
		delete[] buf;
		return TRUE;
		}
	delete[] buf;
	return FALSE;
	};

int WINAPI _export GetBufferLine(LPSTR src,LPSTR dst,int dstsize)
	{
	static LPSTR			Source = NULL;
	static WORD       cnt_s;
	BOOL							EoL = FALSE;
	char							data;
	int               cnt_d = 0;

	if(src != NULL)
		{
		Source = src;
		cnt_s = 0;
		}
	if(!Source) return FALSE;
	if(Source[cnt_s] == '\0') return FALSE;
	do {
		data = Source[cnt_s++];
		switch(data) {
			case '\n': case '\r':
			data = Source[cnt_s++];
			if(EoL) goto Ready;
			EoL = TRUE;
			continue;

			case '\0':
			dst[cnt_d] = '\0';
			return R_EndOfFile;

			default:
			dst[cnt_d++] = data;
			}
		}
		while(cnt_d < dstsize);
Ready:
	dst[cnt_d] = '\0';
	return TRUE;
	};

int WINAPI _export GetFileLine(int hFile,LPSTR dst,int dstsize)
	{
	char  data;
	BOOL	EoL = FALSE;
	int 	cnt = 0;
	int 	rdl;

	dst[cnt] = '\0';
	if(hFile == -1) return FALSE;
	do
		{
		rdl = _lread(hFile,&data,1);
		switch(data) {
			case '\n': case '\r':
			rdl = _lread(hFile,&data,1);
			if(EoL) goto Ready;
			EoL = TRUE;
			continue;

			case '\0':
			dst[cnt] = '\0';
			return R_EndOfFile;

			default:
			if(EoL) goto Ready;
			dst[cnt++] = data;
			}
		}
		while(cnt < dstsize);
Ready:
	_llseek(hFile,-1,SEEK_CUR);
	dst[cnt] = '\0';
	if(cnt == dstsize)
		{
		// overflow dst
		return R_Overflow;
		};
	if(!rdl) return R_EndOfFile;
	return TRUE;
	};

TUnitType WINAPI _export UnitEnum(LPSTR sz_unit)
	{
	char  buf[MaxString];
	strcpy(buf,sz_unit);
	strupr(buf);
	if(strstr((LPSTR)buf,"GRAD"))	 			return Grad;
	if(strstr((LPSTR)buf,"SEKUNDEN")) 	return Sekunden;
	if(strstr((LPSTR)buf,"MINUTEN")) 		return Minuten;
	if(strstr((LPSTR)buf,"MINUTS")) 		return Minuten;
	if(strstr((LPSTR)buf,"MILLIMETER")) return Millimeter;
	if(strstr((LPSTR)buf,"MIKROMETER")) return Mikrometer;
	if(strstr((LPSTR)buf,"MIKCOMETER")) return Mikrometer;
	if(strstr((LPSTR)buf,"CHANNEL")) 		return Channel;
	return None;
	};

LPSTR WINAPI _export UnitStr(TUnitType n_unit)
	{
	switch(n_unit) {
		case Grad:			return "Grad";
		case Minuten:   return "Minuten";
		case Sekunden:  return "Sekunden";
		case Millimeter:return "Millimeter";
		case Mikrometer:return "Mikrometer";
		case Channel:   return "Channel";
		default: 				return "None";
		}
	};

void WINAPI _export Delay(long count)
	{
	// Diese Funktion keinesfalls verndern
	long d1, corr=920, m=0;
	if(count == 0) return;
	if(count>0)
		count--;
	for(d1=0;d1<(count*11+corr);d1++)
		m=m+1;
	};

void WINAPI _export DelayTime(int MilliSec)
	{
	DWORD StartTime = timeGetTime();
	Delay(1);
	while((timeGetTime()-StartTime) <= MilliSec)
		Delay(1);
	};

int WINAPI _export maxi(int value1, int value2)
	{
	return ( (value1 > value2) ? value1 : value2);
	};
int WINAPI _export mini(int value1, int value2)
	{
	return ( (value1 < value2) ? value1 : value2);
	};
long WINAPI _export maxl(long value1, long value2)
	{
	return ( (value1 > value2) ? value1 : value2);
	};
long WINAPI _export minl(long value1, long value2)
	{
	return ( (value1 < value2) ? value1 : value2);
	};
float WINAPI _export maxf(float value1, float value2)
	{
	return ( (value1 > value2) ? value1 : value2);
	};
float WINAPI _export minf(float value1, float value2)
	{
	return ( (value1 < value2) ? value1 : value2);
	};
double WINAPI _export maxd(double value1, double value2)
	{
	return ( (value1 > value2) ? value1 : value2);
	};
double WINAPI _export mind(double value1, double value2)
	{
	return ( (value1 < value2) ? value1 : value2);
	};
// __LastLine__


