#ifndef __M_DEVHW_H
#define __M_DEVHW_H
// (C) 1993,95 by Heiko Damerow
// MPG AG "Roentgenbeugung an Schichtstrukturen"

#include    "am9513a.h"
#include    "mtxpro.inc"
#include    "m_psd.h"
#include    "radicon.h"
#include		"am9513a.h"

class TGenericDevice : public TDevice, TAm9513a
	{
	public:
										TGenericDevice();
	int               Initialize(void);
	BOOL              InitializeEvent(HWND,int);
	static CALLBACK 	TGenericDevice::EventHandler(UINT,UINT,DWORD,DWORD,DWORD);

	protected:
	BOOL              SetSound(void);
	int								SetParameters(void);
	int 							MeasureStart(void);
	int 							MeasureStop(void);
	int								PollDevice(void);
	};

class TEncoder : public TDevice
	{
	public:           TEncoder(void);
										~TEncoder(void);
	int               Initialize(void);
	int               GetData(float &);
	int               GetData(TCurve &) {return 0;};
	int               GetData(WORD *,WORD,WORD) {return 0;};

	private:
	double            dRealTime;
	BOOL              bAnnounceActiv;
	int								PollDevice(void);
	};

class TCommonDevParam : public TModalDlg
	{
	public: 				TCommonDevParam(const int);

	private:
	HWND            hDeviceList;
	TDevice*				Device;
	BOOL            Dlg_OnInit(HWND,HWND,LPARAM);
	void            Dlg_OnCommand(HWND,int,HWND,UINT);
	BOOL            CanClose(void);
	BOOL            LeaveDialog(void);
	};

class TRadicon : public TDevice
	{
	friend	class TScsParameters;

	public:   				TRadicon();
										~TRadicon();
	int               Initialize(void);
	BOOL              InitializeEvent(HWND,int);
	static void CALLBACK TRadicon::EventHandler(UINT,UINT,DWORD,DWORD,DWORD);


	protected:
	BOOL              PSound(int,long);
	void							SetSpezificParametersDlg(void);
	BOOL              FailureOccured(int,int);
	BOOL              SetSound(void);
	int								SetParameters(void);
	int 							MeasureStart(void);
	int 							MeasureStop(void);
	int								PollDevice(void);

	double            dRealTime;
	static int        Rdd;
	static int        Rcc;
	WORD              wDacUpperThresh;
	WORD              wDacLowerThresh;
	WORD              wHighVoltage;
	BOOL              bAnnounceActiv;
	};

class TMatrox : public TDevice
	{
	friend class 			TCCD_Controller;
	friend class 			TMatroxParam;

	public:  					TMatrox(void);
										~TMatrox(void);
	int               Initialize(void);
	int               InitBoard(void);
	int               Measurement(int);
	BOOL              SaveAsTiff(char *);
	BOOL              SavePicture(char *);
	BOOL              LoadPicture(char *);
	int								SingleStepMeasurement(int);
	BOOL              ImageStop(void);
	BOOL              ImageClose(void);

	protected:
	int               FramesNumber;
	int               FrameSource;
	int               BinaryLevel;
	int               xo,dx,yo,dy;
	int               SurfaceId;
	int               nLogCamera;
	int               nCameraType;
	int               SkipTime;
	int               ScanTime;
	char              strLogCamera[5][30];
	BOOL              Interlaced;
	BOOL              ImageInProcess;
	// Anfallende Daten
	short             MinInten,MaxInten,Differenz;
	int               ActualCount;
	int               ObjectQuantity;

	private:
	void							SetSpezificParametersDlg(void);
	BOOL              LabelPicture(void);
	BOOL              ConvolPicture(void);
	BOOL              BinaryPicture(void);
	BOOL              BvTest(void);
	int               GrabPicture(int);
	int               EventCounting(int);
	int               Accumulation(int);
	int               Histogram(int);
	HWND              ImageChildWindow;
	int               hImage;
	HANDLE            hField;
	int               field[512];
	FILE              *picture;
	TIMVALSTRUCT      TimingValues;
	int               hFile;
	short             fifobuf[256];
	short             buflen;
	BOOL              WriteTag(WORD,WORD,DWORD,DWORD,HFILE);
	long              FileLength(int);
	};

class TScsParameters : public TModalDlg
	{
	public:     		TScsParameters();

	private:
	TRadicon        *Device;
	BOOL            Dlg_OnInit(HWND,HWND,LPARAM);
	void            Dlg_OnCommand(HWND,int,HWND,UINT);
	BOOL            CanClose(void);
	BOOL            LeaveDialog(void);
	};
#endif    
// __M_DEVHW_H
// __LastLine__
