#include    "rc_def.h"
#include    "comhead.h"
#pragma hdrstop
// m_main.cpp
// (C) 1993,95 by Heiko Damerow MPG AG "Roentgenbeugung"
// (C) 1996 by Heiko Damerow DLR/DFD

#define ExcludeLScan
#include		"m_devcom.h"
#include    "m_steerg.h"
#include    "m_topo.h"
#include    "m_xscan.h"
#include    "m_dlg.h"

#include		"help_def.h"

#include    <shellapi.h>

#ifdef Use_Scanner
	#include	"st_layer.h"
#endif
#include	"l_layer.h"
#include	"m_layer.h"
#include	"c_layer.h"

static  char     mainVersion[] = "V 1.52 ("__DATE__")";

#ifdef GermanVersion
char strFailure[] = "Fehler";
char strMessage[] = "Meldung";
char strMessage01[] = "Messung wird abgebrochen";
char strMessage02[] = "Zu viele Fenster !";
char strMessage03[] = "Daten wurden noch nicht gesichert.\n Sichern ?";
char strMessage04[] = "Messung &weiterfhren";
char strMessage05[] = "Messung &unterbrechen";
char strMessage06[] = "Das Motorsteuer-Modul ist noch anderweitig in Benutzung !";
char strMessage07[] = "Neustart";
char strMessage08[] = "Endlage von Motor %d angesprochen.";
char strMessage09[] = "Motor-Steuerung";
char strMessage10[] = "Programm wurde erfolgreich gestartet";
char strMessage11[] = "Probleme beim Starten des Programms";
char strMessage12[] = "Bitte ein Darstellungs-Fenster ffnen !";
char strMessage13[] = "Die Messung wurde abgeschlossen !";
char strMessage14[] = "File wurde bereits gespeichert !";
char strMessage15[] = "Fehler beim Starten einer Me-Funktion.";
#else
char strFailure[]   = "Failure";
char strMessage[]   = "Message";
char strMessage01[] = "Measurement interrupted";
char strMessage02[] = "Too many windows !";
char strMessage03[] = "The data wasn't saved !\n Savig ?";
char strMessage04[] = "&Continuous the measurement";
char strMessage05[] = "&Interrupt the measurement";
char strMessage06[] = "The drive module is always used!";
char strMessage07[] = "Restart";
char strMessage08[] = "Limit from drive %d hit";
char strMessage09[] = "Motor-Steering";
char strMessage10[] = "Program started successful";
char strMessage11[] = "Problems with starting program";
char strMessage12[] = "Please open a view window!";
char strMessage13[] = "Measurement completed !";
char strMessage14[] = "File was already saved !";
char strMessage15[] = "Fehler beim Starten einer Me-Funktion.";
#endif

extern TModelessDlg* TheModeless;

// Message Cracker's defined in windowsx.h
				UINT					wm_WakeUpSteering;
const  	int  					WatchStart           	= 0;
const  	int  					TargetStart           = 10;
const  	int  					ReflectionStart       = 100;
const  	int  					FlagStart             = 150;
const  	int  					TextStart             = 250;
const  	int  					WindowMenuPos         = 4;
static 	BOOL					bEnvInstalled					= FALSE;
static 	int  					StatusLineHeight      = 25;
static 	int 					retval;
static	TWorkPlace		WorkPlace							= RTK;
static	BOOL					tfF1Pressed						= FALSE;
static	BOOL					nStartupReport				= 0;
static 	HGDIOBJ 			testobc;
static 	BOOL 					bShutdown 						= FALSE;
static 	char					buf[MaxString];
static 	int 					AreaScanExtention			= 0;
static 	int 					ScanExtention     		= 0;
static 	int 					MacroExtention  			= 0;
static 	int 					AdjustmentExtention   = 0;
static 	int 					TopographyExtention   = 0;
static 	int 					ScanTableExtention    = 0;

				HINSTANCE 		TMain::hInstance 			= 0;
				HINSTANCE 		TMain::hPrevInstance 	= 0;
				int 					TMain::nCmdShow 			= 0;
				HACCEL				TMain::hAccellerator	= 0;
				HWND					TMain::hWndFrame 			= 0;
				HWND					TMain::hWndClient     = 0;
				HINSTANCE   	hMDLL;
				HINSTANCE   	CountersDLLInstance;
				HINSTANCE     hModuleInstance;
				LPCSTR 				szApplication         = "Steuerprogramm";
				TMain  				Main 	 								= TMain();
				LPDList 			lpDList;
				LPDataBase 		lpDBase;

extern 	TSteering			Steering;
extern 	TTopography 	Topography;

				BOOL          bNoConfigurationFile;
				BOOL					bManualMovesCorrected = FALSE;
//******************************************************************************
//******************************************************************************
//******************************************************************************
int TMain::MessageLoop(void)
	{
	MSG   msg;
	BOOL  fQuit = FALSE;

	while(GetMessage(&msg,NULL,0,0))
	// while(PeekMessage(&msg,NULL,0,0,PM_REMOVE))
		{
		/*
		if(TheModeless)
			if(!IsDialogMessage(TheModeless->GetHandle(),&msg))
				{
				if(msg.message == WM_QUIT)
					return 0l;
				}
		*/
		if( !TranslateMDISysAccel(hWndClient,&msg) &&
				!TranslateAccelerator(hWndFrame,hAccellerator,&msg))
			{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
			}
		}
	return 0;
	};

BOOL  TMain::GetVersion(LPSTR vers)
	{
	HGLOBAL   hVersion;
	LPSTR     lpVersion;
	HRSRC     hRes;

	hRes = (HRSRC)FindResource(hInstance,"Version",RT_RCDATA);
	hVersion = LoadResource(hInstance,hRes);
	lpVersion = (LPSTR)LockResource(hVersion);
	strcpy(vers,lpVersion);
	strcat(vers,"  __DATE__");
	FreeResource(hVersion);
	return TRUE;
	};

int PASCAL WinMain( HINSTANCE hInstance,HINSTANCE hPrevInst,LPSTR,int cmdShow)
	{
	WNDCLASS  wndClass;
	BOOL			bExist;
	ATOM			hAtom;

	TMain::hInstance 			= hInstance;
	TMain::hPrevInstance 	= hPrevInst;
	TMain::nCmdShow  			= cmdShow;

	if(bNoConfigurationFile)
		{
		#ifdef GermanVersion
		MessageBox(GetFocus(),"Kein Konfigurationsfile !","Fehler",MBSTOP);
		#else
		MessageBox(GetFocus(),"Configuration file not founded !","Failure",MBSTOP);
		#endif
		exit(4);
		}
	if (!TMain::hPrevInstance)
		{
		bExist = GetClassInfo(NULL,szApplication,&wndClass);
		wndClass.style          = CS_HREDRAW | CS_VREDRAW;
		wndClass.lpfnWndProc    = FrameWndProc;
		wndClass.cbClsExtra     = 0;
		wndClass.cbWndExtra     = 0;
		wndClass.hInstance      = hInstance;
		wndClass.hIcon          = LoadIcon( Main.hInstance,
																				MAKEINTRESOURCE(icon_Application));
		wndClass.hCursor        = LoadCursor(NULL,IDC_ARROW);
		wndClass.hbrBackground  = (HBRUSH)COLOR_APPWORKSPACE + 1;
		wndClass.lpszMenuName   = NULL;
		wndClass.lpszClassName  = szApplication;
		hAtom = RegisterClass(&wndClass);
		}
		else
		{
		// single instance allowed
		// SetActivWindow(hPrevInst);
		exit(0);
		}
	hModuleInstance = hInstance;
	int cnt = 100;
	while(!SetMessageQueue(cnt--));

	TMain::hAccellerator 		= LoadAccelerators(Main.hInstance,MAKEINTRESOURCE(ACC_Main));
	Main.wm_DrawStatus		 	= RegisterWindowMessage("DrawStatus");
	wm_WakeUpSteering  			= RegisterWindowMessage("WakeUpSteering");
	Main.hTheMenu 					= CreateMenu();
	TMain::hWndFrame = CreateWindow(szApplication,szApplication, \
													MainWindow_Style,5,5,500,500, \
													NULL,NULL,hInstance,NULL);
	ShowWindow(TMain::hWndFrame,TMain::nCmdShow);
	UpdateWindow(Main.hWndFrame);
	cnt = SetTimer(Main.hWndFrame,2000,30000,NULL);
	if(cnt)
		KillTimer(Main.hWndFrame,2000);
		else
#ifdef GermanVersion
		MessageBox(GetFocus(),"Keine Timer verfgbar !","System-Fehler",MBSTOP);
#else
		MessageBox(GetFocus(),"No Timer available !","System-Failure",MBSTOP);
#endif
	// initialize hardware
	Main.SetParameters();
	FORWARD_WM_COMMAND(Main.hWndFrame,cm_Initialization,0,0,SendMessage);
	return TMain::MessageLoop();
	};

void ShowProgramStatus(HWND hwnd)
	{
	char  buf[MaxString];
	char  fn[MaxString];
	char  info[3*MaxString];

	GetModuleFileName(mlGetInstance(),fn,MaxString);
	sprintf(buf,"Drive   : %s [%s]\n\n",mlGetVersion(),fn);
	strcpy(info,buf);
	GetModuleFileName(dlGetInstance(),fn,MaxString);
	sprintf(buf,"Device  : %s [%s]\n\n",dlGetVersion(),fn);
	strcat(info,buf);
	GetModuleFileName(spGetInstance(),fn,MaxString);
	sprintf(buf,"Library : %s [%s]\n\n",spGetVersion(),fn);
	strcat(info,buf);
	sprintf(buf,"Main    : %s\n",mainVersion);
	strcat(info,buf);
	MessageBox(hwnd,info,"Versionskontrolle",MBINFO);
	};

LRESULT DoCommandsFrame(HWND hwnd,WPARAM wParam,LPARAM lParam)
	{
	TModalDlg*     dlg;

	switch(GET_WM_COMMAND_ID(wParam,lParam))
		{
		case cm_Initialization:
		Ctl3dRegister(Main.hWndFrame);
		Ctl3dAutoSubclass(Main.hWndFrame);
		if(!InitializeSPLibrary(Main.GetParameters()))
			nStartupReport += 1;
		Main.LoadProfile();
		lpDBase = GetDataBasePtr();
#ifndef __WIN32__
		hMDLL = GetModuleHandle("motors.dll");
		if(!hMDLL)
			MessageBox(GetFocus(),"Bibliothek motors.dll nicht geladen !","Fehler",MBSTOP);
			else
			{
			if(!mlInitializeMotorsDLL())
				nStartupReport += 2;
			mlSetAxis(0);
			}
#else
		if(!mlInitializeMotorsDLL())
			nStartupReport += 2;
		mlSetAxis(0);
#endif
#ifndef __WIN32__
		CountersDLLInstance = GetModuleHandle("counters.dll");
#else
		CountersDLLInstance = GetModuleHandle("device32.dll");
#endif
		if(!CountersDLLInstance)
			MessageBox(GetFocus(),"Bibliothek counters.dll nicht geladen !","Fehler",MBSTOP);
			else
			{
			if(!InitializeCountersDLL())
				nStartupReport += 4;
			lpDList = GetCounterListPtr();
			lpDList->SetDevice(0);
			}
		Main.LoadMenuBar();
		Steering.Initialize(Main.hWndFrame,mlGetAxis(),lpDList->GetDevice());
		Topography.Initialize();
		bEnvInstalled = TRUE;
		//**************************************************************************
		if(Main.bAutoCalibration)
			mlInquireReferencePointDlg(99);
		switch(Main.nStartup) {
			case 0:
			if(AreaScanExtention)
				NewWindow((TMDIWindow *)new TAreaScan());
			break;
			case 1:
			NewWindow((TCounterWindow *)new TCounterWindow(lpDList->GetDevice()));
			break;
			case 2:
			if(ScanExtention)
				NewWindow((TMDIWindow *)new TScan());
			NewWindow((TCounterWindow *)new TCounterWindow(lpDList->GetDevice()));
			break;
			case 3:
			NewWindow((TCounterWindow *)new TCounterWindow(lpDList->GetDevice()));
			PostMessage(hwnd,WM_COMMAND,cm_AngleControl,0);
			break;
#ifndef ExcludeLScan
			case 4:
			if(ScanTableExtention)
				NewWindow((TMDIWindow *)new TOffLineScan());
			break;
#endif
			case 5:
			if(MacroExtention)
				PostMessage(hwnd,WM_COMMAND,cm_CallExecuteMacro,0);
			break;
			case 6:;
			break;
			default:
			NewWindow((TCounterWindow *)new TCounterWindow(lpDList->GetDevice()));
			}
		if(nStartupReport)
			sprintf(buf,"%s (%d)",strMessage11,nStartupReport);
			else
			sprintf(buf,"%s",strMessage10);
		SetInfo(buf);
		return TRUE;

		case cm_Exit:
		if(tfF1Pressed)
			{
			WinHelp(hwnd,"SPHELP.HLP",HELP_CONTEXT,Help_Exit);
			tfF1Pressed = FALSE;
			}
		// Iterate through all child windows.  If still can close then
		FORWARD_WM_DESTROY(hwnd,PostMessage);
		return TRUE;

		case cm_PosControl:
		mlPositionControlDlg();
		return TRUE;

		case cm_Calibrate:
		mlInquireReferencePointDlg(0);
		return TRUE;

		case cm_CallExecuteMacro:
		if(!MacroExtention) return TRUE;
		if(!TheModeless)
			{
			TheModeless = (TMacroExecute*)new TMacroExecute();
			TheModeless->Initialize();
			}
			else
			delete TheModeless;
		return TRUE;

		case cm_CallExecuteCounter:
		NewWindow((TCounterWindow *)new TCounterWindow(LOWORD(lParam)));
		return TRUE;

		case cm_MeasurementParam:
		dlg = (TMeasurementParam *)new TMeasurementParam();
		dlg->ExecuteDialog(hwnd);
		delete dlg;
		SetInfo("");
		return TRUE;

		case cm_AngleControl:
		dlg = (TAngleControl *)new TAngleControl();
		dlg->ExecuteDialog(hwnd);
		delete dlg;
		return TRUE;

		case cm_SetWatchIndicator:
		Main.SetWatchIndicator(lParam);
		return TRUE;

		case cm_LimitHitOccure:
		{
		char	buf[MaxString];

		sprintf(buf,strMessage08,(int)lParam);
		MessageBox(hwnd,buf,strMessage09,MBINFO);
		}
		return TRUE;

		case cm_TopograpyParam:
		dlg = (TTopographySetParam *)new TTopographySetParam(FALSE);
		dlg->ExecuteDialog(hwnd);
		delete dlg;
		return TRUE;

		case cm_MotorParam:
		mlSetParametersDlg();
		return TRUE;

		case cm_SensorParam:
		lpDList->SetParametersDlg();
		return TRUE;

		case cm_OptimizeDC:
		// operates the actual motor
		mlOptimizingDlg();
		return TRUE;

		case cm_SetAngleDefault:
		mlSetAngleDefault();
		return TRUE;

		case cm_About:
		AboutTheMaker();
		return TRUE;

		case cm_AllVersions:
		ShowProgramStatus(hwnd);
		return TRUE;

		case cm_Directories:
		dlg = new TModalDlg("Directories");
		dlg->ExecuteDialog(hwnd);
		delete dlg;
		return TRUE;

		case cm_CallExecuteTopograpy:
		dlg = (TTopographyExecute *)new TTopographyExecute();
		dlg->ExecuteDialog(hwnd);
		delete dlg;
		return TRUE;

		case cm_CallExecuteCmd:
		dlg = (TExecuteCmd*)new TExecuteCmd();
		dlg->ExecuteDialog(hwnd);
		delete dlg;
		return TRUE;

		case cm_CallExecuteAdjustment:
		if(Main.hAdjustmentWindow) return TRUE;
		NewWindow((TAdjustmentWindow *)new TAdjustmentWindow());
		return TRUE;

		case cm_CallExecuteScan:
		if(Main.hScanWindow) return TRUE;
		NewWindow((TMDIWindow*)new TScan());
		return TRUE;

		case cm_CallExecuteAreaScan:
		if(Main.hAreaScanWindow) return TRUE;
		NewWindow((TMDIWindow*)new TAreaScan());
		return TRUE;

		case cm_Tile:
		SendMessage(Main.hWndClient,WM_MDITILE,0,0L);
		return TRUE;

		case cm_Cascade:
		SendMessage(Main.hWndClient,WM_MDICASCADE,0,0L);
		return TRUE;

		case cm_ArrangeIcons:
		SendMessage(Main.hWndClient,WM_MDIICONARRANGE,0,0L);
		return TRUE;

		case cm_H_CalibrationDlg:
		if(tfF1Pressed)
			{
			WinHelp(hwnd,"SPHELP.HLP",HELP_CONTEXT,Help_CalibrationDlg);
			tfF1Pressed = FALSE;
			}
		break;

		case  cm_H_AngleControlDlg:
		if(tfF1Pressed)
			{
			WinHelp(hwnd,"SPHELP.HLP", HELP_CONTEXT,Help_AngleControlDlg);
			tfF1Pressed = FALSE;
			}
		break;

		case cm_H_Index:
		WinHelp(hwnd,"SPHELP.HLP",HELP_CONTEXT,Help_Contents);
		break;

		case cm_H_Help:
		WinHelp(hwnd,"SPHELP.HLP",Help_Help,0L);
		break;

		default:
		HWND hChildWnd = (HWND)LOWORD(SendMessage(Main.hWndClient,WM_MDIGETACTIVE,0,NULL));
		if(IsWindow(hChildWnd))
			SendMessage(hChildWnd,WM_COMMAND,wParam,lParam);
		break;
		}
	return FALSE;
	}

void DoSize(HWND hWindow)
	{
	RECT       rect;
	HDC        DC,srcDC,destDC;
	HBITMAP    bmp;
	HANDLE     oldSrc,oldDest;

	GetClientRect(hWindow, &rect);
	MoveWindow(Main.hWndClient,0,0,rect.right,rect.bottom - StatusLineHeight,1);
  InvalidateRect(hWindow,NULL,1);
	DC = GetDC(hWindow);
	srcDC = CreateCompatibleDC(DC);
	destDC = CreateCompatibleDC(DC);
	ReleaseDC(hWindow, DC);

	if(StatusLineHeight == 25)
		bmp = LoadBitmap(Main.hInstance,MAKEINTRESOURCE(bmp_StatusLine25));
		else
		bmp = LoadBitmap(Main.hInstance,MAKEINTRESOURCE(bmp_StatusLine));
	oldSrc = SelectObject(srcDC, bmp);
	if(Main.bmpStatusLine)
		DeleteObject(Main.bmpStatusLine);
	Main.bmpStatusLine = CreateCompatibleBitmap(DC,rect.right,StatusLineHeight);
	oldDest = SelectObject(destDC,Main.bmpStatusLine);
	BitBlt(destDC,0,0,5,StatusLineHeight,srcDC,0,0,SRCCOPY);
	StretchBlt(destDC,5,0,rect.right-5,StatusLineHeight,srcDC,6,0, \
			StatusLineHeight,StatusLineHeight,SRCCOPY);
	BitBlt(destDC,rect.right-5,0,5,StatusLineHeight,srcDC,59,0,SRCCOPY);
	testobc = SelectObject(srcDC,oldSrc);
	testobc = SelectObject(destDC,oldDest);
	DeleteDC(srcDC);
	DeleteDC(destDC);
	DeleteObject(bmp);
	};

LRESULT DoCommandsChild(TMDIWindow *window,HWND hWindow,WPARAM wParam,LPARAM lParam)
	{
	TModalDlg      *dlg;
	WPARAM         Cmd;

	Cmd = GET_WM_COMMAND_ID(wParam,lParam);
	switch(Cmd){
		case cm_Copy:
		window->DoCopy();
		return 0l;

		case cm_Adjustment:
		dlg = (TAdjustmentExecute *)new TAdjustmentExecute(0);
		dlg->ExecuteDialog(hWindow);
		delete dlg;
		return 0l;

#ifndef ExcludeLScan
		case cm_ControlCrossTable:
		dlg = (TCrossTableControl*)new TCrossTableControl();
		dlg->ExecuteDialog(hWindow);
		delete dlg;
		return 0l;
#endif

		case cm_AdjustmentParam:
		dlg = (TSetAdjustmentParam *)new TSetAdjustmentParam();
		dlg->ExecuteDialog(hWindow);
		delete dlg;
		return TRUE;

		case cm_InitializeAreaScan: case cm_InitializeLineScan:
		case cm_InitializeScan:
		case cm_PSD_Scan:           case cm_PSD_AreaScan:
		case cm_InquireCCDLine:     case cm_ShowHistogram:
		window->InitializeTask(wParam,lParam);
		return 0l;

		case cm_SetupCCDLineScan:		case cm_ImageSaveOptions:
		case cm_SetupStepScan:  		case cm_SetupContinuousScan:
		case cm_SetupAreaScan:      case cm_DataAquisition:
		window->InitializeDlg(wParam,lParam);
		return 0l;

		case cm_ChooseScan:      case cm_ShowPsdE_Data:
		case cm_ShowPsdP_Data:   case cm_SetupPsd:
		window->CallLocalAction(wParam,lParam);
		return 0l;

		case cm_InterruptAction:
		window->Interrupt();
		return 0l;

		case cm_StopAll:
		{
		int	id = 0;

		while(mlSetAxis(id++))
			mStopDrive(0);
		MessageBox(GetFocus(),"Trial to stop all drives !","Message",MBINFO);
		}
		return 0l;

		case cm_GrabPicture:
		return 0l;

		case cm_GetHistogram:
		return 0l;

		case cm_AccuPicture:
		return 0l;

		case cm_EventCounting:
		return 0l;

		case cm_SensorParam:
		lpDList->SetParametersDlg();
		return TRUE;

		//*** Ablauf-Steuerung *****************************************************
		case cm_CounterSet:
		window->CounterSetRequest(lParam);
		return 0l;

		case cm_DistanceSet:
		window->DistanceSetRequest(lParam);
		return 0l;

		case cm_SteeringReady:
		window->SteeringReady(lParam);
		return 0l;

#ifdef CCD_ExtentionOK
		//*** Bildbearbeitungs-Funktionen ******************************************
		case cm_BvTest: case cm_ConvolPicture: case cm_BinaryPicture:
		case cm_LabelPicture: case cm_MIL0:
		lpDList->DP(lpDList->MD_Matrox)->SingleStepMeasurement(wParam);
		return 0l;

		case cm_ImageParam:
		dlg = (TMatroxParam *)new TMatroxParam((TMatrox *)window);
		dlg->ExecuteDialog(hWindow);
		delete dlg;
		return 0l;
		//**************************************************************************
#endif
		case cm_ShowCurveParam:
		dlg = (TCurveShowParam *)new TCurveShowParam((TPlotData *)window);
		dlg->ExecuteDialog(hWindow);
		window->UpdateWnd(0);
		delete dlg;
		return 0l;

		case cm_MoveScanReady:
		if(lParam != 888l)
			break;
		{
		int				      cnt;
		char			      Msg[MaxString];
		TKSProperties   ksp;
		float			      x,y,z;
		TCurve*		      crv = new TCurve(mGetScanSize()+10);
		LPLONG		      data = mGetMoveScan();
		long			      yo = data[0];

		crv->FastOpen();
		for(cnt=0;cnt<mGetScanSize();cnt++)
			{
			x = z = cnt;
			y = (data[cnt] - yo);
			crv->FastPAdd(x,y,z);
			}
		crv->FastClose();
		ksp.bLogarithmicY = FALSE;
		ksp.fMinX = 0.0; ksp.fMaxX = (float)mGetScanSize() * 1.1;
		ksp.fMinY = 0.01; ksp.fMaxY = (float)(data[cnt-1] - yo) * 1.3;
		Main.ScanWindow->SetKSProperties(&ksp);
		Main.ScanWindow->PickUpData((LPARAM)(TCurve*)crv);
		// SendMessage(Main.hScanWindow,WM_COMMAND,cm_PlotCurve,(LPARAM)(TCurve*)crv);
		sprintf(Msg,"MoveFinish: %ld >>> Letzter Wert: %ld",data[mGetMoveFinishIdx()]-yo,data[mGetScanSize()-1]-yo);
		SetInfo(Msg);
		delete crv;
		}
		SendMessage(hWindow,WM_SETFOCUS,0,0l);
		return 0l;

		case cm_PlotCurve:
		window->PickUpData(lParam);
		SendMessage(hWindow,WM_SETFOCUS,0,0l);
		return 0l;

		case cm_SetProperties:
		window->SetKSProperties((TKSProperties*)lParam);
		return 0l;

		case cm_ShowCounterParam:
		dlg = (TCounterShowParam *)new TCounterShowParam((TCounterWindow *)window);
		dlg->ExecuteDialog(hWindow);
		delete dlg;
		return 0l;

		case cm_SetRanges:
		window->SetRanges();
		if(lParam)
			window->UpdateWnd(0);
		return 0l;

		case cm_SaveSecondCurve:
		window->SaveSecondCurve();
		return 0l;

		case cm_KillSecondCurve:
		window->KillSecondCurve();
		return 0l;

		case cm_FreezeCurve:
		window->FreezeCurve();
		return 0l;

		case cm_CalibratePsd:
		window->CalibratePsd();
		return 0l;

		case cm_PSDRemoteSyncCtl:
		window->ExternSychronized();
		return 0l;


		case cm_Logging:
		if(0 == strcmp(window->ClassName(),"MDevice"))
			((TCounterWindow*)window)->SetupLogging();
		return 0l;

		case cm_ShowDigital:
		if(0 == strcmp(window->ClassName(),"MDevice"))
			((TCounterWindow *)window)->bShowAsDigital = TRUE;
		return 0l;

		case cm_ShowAnalog:
		if(0 == strcmp(window->ClassName(),"MDevice"))
			((TCounterWindow *)window)->bShowAsDigital = FALSE;
		return 0l;

		case cm_Open:
		window->LoadOldData(LOWORD(lParam));
		window->SetRanges();
		return 0l;

		case cm_New:
		window->SetFileName("");
		window->New();
		return 0l;

		case cm_Save:
		window->SaveFile(0);
		return 0l;

		case cm_SaveAs:
		window->SaveFileAs();
		return 0l;

		case cm_UpdateFile:
		window->UpdateFile();
		return 0l;
		}
	return 100000l;
	};

void DoPaint(HWND hWindow)
	{
	HDC           PaintDC;
	PAINTSTRUCT   ps;

	if(bShutdown)
		return;
	PaintDC = BeginPaint(hWindow,&ps);
	Main.BlastStatusLine(hWindow,PaintDC,0);
	Main.SetWatchIndicator(3);
	EndPaint(hWindow,&ps);
	};

void TMain::BlastStatusLine(HWND hWindow,HDC hDC,int StatusId)
	{
	HDC				hMemDc;
	RECT      Rect;
	LOGFONT   lf;
	int				dx,dy,xo,yo,yo2;
	char      buf[MaxString],buf2[20];
	HFONT     hSmall,hOld;
	SIZE      size;

	if(bShutdown)
		return; // Fail by stop program
	// Zeichnen der aktuellen StatusInformation
	GetClientRect(hWindow,&Rect);
	dx = Rect.right - Rect.left; dy = StatusLineHeight;
	xo = 0; yo = Rect.bottom - StatusLineHeight;
	hMemDc = CreateCompatibleDC(hDC);
	SelectObject(hMemDc,Main.bmpStatusLine);
	hOld = (HFONT)GetStockObject(ANSI_VAR_FONT);
	if(hOld)
		{
		GetObject(hOld,sizeof(LOGFONT),(LPSTR)&lf);
		lf.lfHeight += 2;
		lf.lfWidth = 0;
		hSmall = CreateFontIndirect( &lf);
		if(hSmall)
			hOld = (HFONT)SelectObject(hDC,(HFONT)hSmall);
		}
	switch(StatusId) {
		case 0: // Alles Neuzeichnen nach Paint
		GetTextExtentPoint(hDC,StatusInfo,1,&size);
		SetBkColor(hDC,RGB(192,192,192));
		dx -= TextStart; if(dx<0) dx = 0;
		yo2 = yo + (StatusLineHeight - size.cy) / 2;
		BitBlt(hDC,TextStart,yo,dx,dy,hMemDc,0,0,SRCCOPY);
		TextOut(hDC,TextStart+5,yo2,StatusInfo,strlen(StatusInfo));
		dx = ReflectionStart - TargetStart;  if(dx<0) dx = 0;
		BitBlt(hDC,TargetStart,yo,dx,dy,hMemDc,0,0,SRCCOPY);
		dx = FlagStart - ReflectionStart;  if(dx<0) dx = 0;
		BitBlt(hDC,ReflectionStart,yo,dx,dy,hMemDc,0,0,SRCCOPY);
		sprintf(buf,"%s",Main.Target);
		TextOut(hDC,TargetStart+5,yo2,(LPSTR)buf,strlen(buf));
		GetHKL(Main.Reflection,buf2);
		sprintf(buf,"%s",buf2);
		TextOut(hDC,ReflectionStart+5,yo2,(LPSTR)buf,strlen(buf));
		dx = TextStart - FlagStart;  if(dx<0) dx = 0;
		BitBlt(hDC,FlagStart,yo,dx,dy,hMemDc,0,0,SRCCOPY);
		strcpy(buf,Main.AdditionalInfo);
		TextOut(hDC,FlagStart+5,yo2,buf,strlen(buf));
		break;

		case 1000: // Ausgabe der aktuellen Probe und des untersuchten Reflex
		SetBkColor(hDC,RGB(192,192,192));
		GetTextExtentPoint(hDC,buf,1,&size);
		yo2 = yo + (StatusLineHeight - size.cy) / 2;
		dx = ReflectionStart - TargetStart;
		if(dx<0)
			dx = 0;
		BitBlt(hDC,TargetStart,yo,dx,dy,hMemDc,0,0,SRCCOPY);
		dx = FlagStart - ReflectionStart;
		if(dx<0)
			dx = 0;
		BitBlt(hDC,ReflectionStart,yo,dx,dy,hMemDc,0,0,SRCCOPY);
		sprintf(buf,"%s",Main.Target);
		TextOut(hDC,TargetStart+5,yo2,(LPSTR)buf,strlen(buf));
		GetHKL(Main.Reflection,buf2);
		sprintf(buf,"%s",buf2);
		GetTextExtentPoint(hDC,buf,1,&size);
		TextOut(hDC,ReflectionStart+5,yo2,(LPSTR)buf,strlen(buf));
		break;

		case 1001: // Ausgabe der Zustands-Information
		dx = TextStart - FlagStart;  if(dx<0) dx = 0;
		SetBkColor(hDC,RGB(192,192,192));
		GetTextExtentPoint(hDC,StatusInfo,1,&size);
		yo2 = yo + (StatusLineHeight - size.cy) / 2;
		BitBlt(hDC,FlagStart,yo,dx,dy,hMemDc,0,0,SRCCOPY);
		strcpy(buf,Main.AdditionalInfo);
		TextOut(hDC,FlagStart+5,yo+((StatusLineHeight-size.cy)/2),buf,strlen(buf));
		break;

		case 1002: case 4: // Ausgaber der Status-Information
		dx -= TextStart; if(dx<0) dx = 0;
		BitBlt(hDC,TextStart,yo,dx,dy,hMemDc,0,0,SRCCOPY);
		SetBkColor(hDC,RGB(192,192,192));
		GetTextExtentPoint(hDC,StatusInfo,1,&size);
		TextOut(hDC,TextStart+5,yo+((StatusLineHeight-size.cy)/2),StatusInfo,strlen(StatusInfo));
		}
	if(hOld) 		testobc = SelectObject(hDC,hOld);
	if(hSmall)  DeleteObject(hSmall);
	DeleteDC(hMemDc);
	};

void TMain::DrawStatus(HWND hWindow,ATOM hAtom,int InfoId)
	{
	HDC       hDC;

	if(bShutdown)
		return;
	hDC = GetDC(hWindow);
	switch(InfoId) {
		case 0:
		strcpy(StatusInfo,"");
		break;
		case 1001:
		if(!hAtom) break;
		GlobalGetAtomName(hAtom,(LPSTR)AdditionalInfo,MaxString);
		GlobalDeleteAtom(hAtom);
		break;
		case 4: case 1002:
		if(!hAtom) break;
		GlobalGetAtomName(hAtom,(LPSTR)StatusInfo,MaxString);
		GlobalDeleteAtom(hAtom);
		break;
		}
	BlastStatusLine(hWindow,hDC,InfoId);
	ReleaseDC(hWindow,hDC);
	};

void MenuSelect(HWND hWindow,WPARAM wParam,LPARAM lParam)
	{
	char  String[MaxString];
	int   StrID;
	ATOM  hAtom;

	if(0xFFFF == (WORD)GET_WM_COMMAND_HWND(wParam,lParam))
		{
		Main.CurrentPopup = 0;
		Main.CurrentID = 0;
		return;
		}
	if(MF_POPUP & (UINT)GET_WM_COMMAND_HWND(wParam,lParam))
		{
		Main.CurrentPopup = (HMENU)GET_WM_COMMAND_ID(wParam,lParam);
		switch(GetMenuItemID(Main.CurrentPopup,0)) {
			case cm_New:           StrID = sth_File; break;
			case cm_Tile:          StrID = sth_Window; break;
			case cm_Directories:   StrID = sth_Option; break;
			case cm_Preferences:   StrID = sth_OptionsEnvironment; break;
			case cm_Index:         StrID = sth_Help; break;
			default:  StrID = sth_Info;
			}
		Main.CurrentID = 0;
		retval = LoadString(Main.hInstance,StrID,String,sizeof(String));
		hAtom = GlobalAddAtom((LPSTR)String);
		if(hAtom)
			PostMessage(hWindow,Main.wm_DrawStatus,4,(LPARAM)hAtom);
		return;
		}
	Main.CurrentID = GET_WM_COMMAND_ID(wParam,lParam);
	switch(Main.CurrentID){
		case cm_New:           StrID = sth_FileNew; break;
		case cm_Open:          StrID = sth_FileOpen; break;
		case cm_Save:          StrID = sth_FileSave; break;
		case cm_SaveAs:        StrID = sth_FileSaveAs; break;
		case cm_Print:         StrID = sth_FilePrint; break;
		case cm_Exit:          StrID = sth_FileExit; break;
		case cm_Directories:   StrID = sth_OptionsDirectory; break;
		case cm_OptionsSave:   StrID = sth_OptionsSave; break;
		case cm_Tile:          StrID = sth_WindowTile; break;
		case cm_Cascade:       StrID = sth_WindowCascade; break;
		case cm_ArrangeIcons:  StrID = sth_WindowArrange; break;
		case cm_CloseAll:      StrID = sth_WindowCloseAll; break;
		case cm_Measurement:   StrID = sth_Measurement; break;
		case cm_Index:         StrID = sth_HelpIndex; break;
		case cm_About:         StrID = sth_HelpAbout; break;
		default:  StrID = sth_Info;
		}
	retval = LoadString(Main.hInstance,StrID,String,sizeof(String));
	hAtom = GlobalAddAtom((LPSTR)String);
	if(hAtom)
		PostMessage(hWindow,Main.wm_DrawStatus,4,(LPARAM)hAtom);
	};

BOOL CreateMdiClientWindow(HWND hWnd)
	{
	CLIENTCREATESTRUCT  ClientCreate;      // MDI-ClientWindow Datenstruktur
																				 // auf die bei der Fenstererstellung
																				 // zugegriffen wird
	/*
	Bezug zum "Fenster"-Popup Menu innerhalb der MDI-FrameWindow
	Menueleiste holen. In dieses Menu traegt die Clienten-Fensterfunktion
	a5tomatisch den Titel eines MDI-Kindfensters, wenn dieses geoeffnet
	wird und entfernt ihn daraus, wenn es wieder geschlossen wird.
	*/
	ClientCreate.hWindowMenu =  GetSubMenu(Main.hTheMenu,1);
	/*
	Vergabe einer eindeutige Kennziffer fuer das erste MDI-ChildWindow.
	Diese Kennziffer wird als wParam Parameter innerhalb einer WM_COMMAND
	Nachricht an das FrameWindow geschickt, wenn der zum MDI-Kindfenster
	gehoerende Eintrag innerhalb des Popup-Menues "Fenster" angewaehlt wurde.
	*/
	ClientCreate.idFirstChild = 2000; // FIRSTCHILDID;
	ClientCreate.hWindowMenu = GetSubMenu(Main.hTheMenu,WindowMenuPos);
	Main.hWndClient = CreateWindow( (LPSTR)"MDIClient",NULL,CLIENTWINDOWSTYLE, \
																	0,0,0,0,hWnd,(HMENU)NULL,Main.hInstance, \
																	(LPSTR)&ClientCreate) ;
	if(StatusLineHeight == 25)
		Main.bmpStatusLine = LoadBitmap(Main.hInstance,MAKEINTRESOURCE(bmp_StatusBar25));
		else
		Main.bmpStatusLine = LoadBitmap(Main.hInstance,MAKEINTRESOURCE(bmp_StatusBar));
	if(!Main.hWndClient) return FALSE;
	ShowWindow(Main.hWndClient,SW_SHOW);
	return TRUE;
	};

LRESULT CALLBACK _export FrameWndProc(HWND hWindow,UINT message,WPARAM wParam,LPARAM lParam)
	{
	// main window handler, called first
	int					nDevice;
	HWND 				hwnd;
	TMDIWindow  *window;
#ifndef __WIN32__
	char      	buf[MaxString];
#endif

	switch(message)
		{
		case WM_CREATE:
		CreateMdiClientWindow(hWindow);
		break;

		case WM_TIMER:
		nDevice = GET_WM_COMMAND_ID(wParam,lParam) - DeviceTimerIdStart;
		if(lpDList->IsValidId(nDevice))
			{
			switch(lpDList->DP(nDevice)->PollDevice()) {
				case R_Failure:
				lpDList->DP(nDevice)->MeasureStop();
				SetStatus(strMessage07);
				MessageBeep(0);
				lpDList->DP(nDevice)->MeasureStart();
				break;
				}
			break;
			}
		// others
		break;

		case WM_SIZE:
		DoSize(hWindow);
		// immediately return, otherhand case no write of status line.
		return 0l;

		case WM_PAINT:
		DoPaint(hWindow);
		break;

		case WM_COMMAND:
		DoCommandsFrame(hWindow, wParam, lParam);
		break;

		case WM_DESTROY:
		bShutdown = TRUE;
		do
			{
			hwnd = (HWND)SendMessage(Main.hWndClient,WM_MDIGETACTIVE,0,0l);
			// Ermitteln des des Fenster-Strucktur-Zeigers
			if(hwnd)
				{
				window = (TMDIWindow *)GetWindowLong(hwnd,1);
				if(window)
					{
					if(window->CanClose())
						SendMessage(Main.hWndClient,WM_MDIDESTROY,(WPARAM)(HWND)hwnd,0l);
					continue;
					}
				}
			break;
			} while(1);
#ifndef __WIN32__
		if(1 < GetModuleUsage(hMDLL))
			{
			strcpy(buf,strMessage06);
			MessageBox(hWindow,buf,szApplication,MBINFO);
			bShutdown = FALSE;
			return 0l;
			}
#endif
		if(bEnvInstalled)
			{
			if(Main.bmpStatusLine != NULL)
				DeleteObject(Main.bmpStatusLine);
			Ctl3dUnregister(Main.hWndFrame);
			lpDList->DeleteDevices();
			delete lpDList;
			mlSaveModuleSettings();
			bEnvInstalled = FALSE;
			}
		Main.SaveProfile();
		PostQuitMessage(0);
		return 0l;

		case WM_SYSCOMMAND:
		switch(wParam) {
			case SC_CLOSE:
			// Anwendung wird noch als Server benutzt
#ifndef __WIN32__
			bShutdown = TRUE;
			if(2 < GetModuleUsage(hMDLL))
				{
				MessageBox(hWindow,strMessage06,szApplication,MBINFO);
				bShutdown = FALSE;
				return 1l;
				}
#endif
			// Es sind eventuell Daten noch nicht gespeichert worden
			do
				{
				hwnd = (HWND)SendMessage(Main.hWndClient,WM_MDIGETACTIVE,0,0l);
				// Ermitteln des des Fenster-Strucktur-Zeigers
				if(NULL == hwnd) break;
				window = (TMDIWindow *)GetWindowLong(hwnd,1);
				if((NULL != window) && hwnd)
					{
					if(window->CanClose())
						{
						SendMessage(Main.hWndClient,WM_MDIDESTROY,(WPARAM)(HWND)hwnd,0l);
						continue;
						}
						else
						{
						bShutdown = FALSE;
						return 1l;
						}
					}
				break;
				} while(1);
			bShutdown = TRUE;
			PostMessage(GetFrameHandle(),WM_DESTROY,0,0l);
			return 1;
			} //switch
		break;

		case WM_MENUSELECT:
		MenuSelect(hWindow,wParam,lParam);
		break;

		case WM_ENTERIDLE:
		if((GET_WM_COMMAND_ID(wParam,lParam) == MSGF_DIALOGBOX)
					&& (GetKeyState(VK_F1) & 0x8000))
			{
			PostMessage((HWND)LOWORD(lParam),WM_COMMAND,cm_Index,0);
			}
		if((GET_WM_COMMAND_ID(wParam,lParam) == MSGF_MENU ) &&
			 ((GetKeyState(VK_F1) & 0x8000) != 0))
			{
			// The key is down if the high order bit is set.
			tfF1Pressed = TRUE;
			PostMessage(hWindow,WM_KEYDOWN,VK_RETURN,0L);
			}
		break;

		default:
		if(message == Main.wm_DrawStatus)
			Main.DrawStatus(hWindow,(ATOM)lParam,GET_WM_COMMAND_ID(wParam,lParam));
		if(message == wm_WakeUpSteering) Steering.WakeUp();
		} // end switch
	return DefFrameProc(hWindow,Main.hWndClient,message,wParam,lParam);
	};

LRESULT CALLBACK _export WndProc(HWND hWindow,UINT message,WPARAM wParam,LPARAM lParam)
	{
	// Fenster-Funktion zu Bedienung der untergeordneten Fenster
	LRESULT        result;
	TMDIWindow     *window;

	// Ermitteln des des Fenster-Strucktur-Zeigers
	window = (TMDIWindow *)GetWindowLong(hWindow,1);
	switch(message)
		{
		case WM_CREATE:
		if(Main.CurrentWindow != NULL)
			 {
			window = Main.CurrentWindow;
			// Setzen des des Fenster-Strucktur-Zeigers
			SetWindowLong(hWindow,1,DWORD(window));
			Main.CurrentWindow = NULL;
			if(window->CanOpen())
				window->Create(hWindow);
				else
				{
				ShowWindow(Main.hWndClient,SW_HIDE);
				SendMessage(Main.hWndClient,WM_MDIDESTROY,(WPARAM)(HWND)hWindow,0l);
				ShowWindow(Main.hWndClient,SW_NORMAL);
				}
			break;
			}
		break;

		case WM_SYSCOLORCHANGE:
		Ctl3dColorChange();
		return 0l;

		case WM_PAINT:
		HDC         hdc;
		PAINTSTRUCT ps;

		hdc = BeginPaint(hWindow,&ps);
		window->Paint(hdc,&ps);
		EndPaint(hWindow,&ps);
		break;
		// return 0l;

		case WM_COMMAND:
		result = DoCommandsChild(window,hWindow,wParam,lParam);
		if(result) break;
		break;

		case WM_TIMER:
		switch(GET_WM_COMMAND_ID(wParam,lParam)) {
			case  TimerIdSteering:
			window->TimerRequest(GET_WM_COMMAND_ID(wParam,lParam));
			return 0l;
			}
		break;

		case WM_RENDERFORMAT:
		window->RenderFormat(wParam);
		break;

		case WM_RENDERALLFORMATS:
		window->RenderAllFormats(wParam);
		break;

		case WM_KEYDOWN:
		switch(wParam) {
			case VK_ESCAPE:
			if(1 < (int)GET_WM_COMMAND_HWND(wParam,lParam))
				{
				// Messung unterbrechen
				MessageBeep(0);
				window->Interrupt();
				}
			}
		break;

		case WM_LBUTTONDOWN:
		window->lButtonDown(wParam,lParam);
		break;

		case WM_LBUTTONUP:
		window->lButtonUp(wParam,lParam);
		break;

		case WM_MOUSEMOVE:
		window->MouseMove(wParam,lParam);
		break;

		case WM_RBUTTONDOWN:
		window->rButtonDown(lParam);
		break;

		case WM_SIZE:
		window->Size(hWindow,wParam,lParam);
		break;

		case WM_SETFOCUS:
		window->SetFocus();
		break;

		case WM_MDIDESTROY:
		if(window->CanClose()) break;
		break;

		case WM_DESTROY:
		// check, whether data set was stored
		if(window->CanClose())
			{
			delete window;
			return DefMDIChildProc(hWindow,WM_DESTROY,wParam,lParam);
			}
		return 0l;
		} // end switch
	return DefMDIChildProc(hWindow,message,wParam,lParam);
	};

//******************************************************************************
//******************************************************************************
TMain::TMain(void)
	{
	char	    buf[MaxString];
	char      Drive[MAXDRIVE],Dir[MAXDIR],Name[MAXFILE],Ext[MAXEXT];
	OFSTRUCT  of;

	fnsplit(_argv[0],Drive,Dir,Name,Ext);
	sprintf(Main.szDirectory,"%s%s",Drive,Dir);
  GetWindowsDirectory(buf,MaxString);
	sprintf(IFile,"%s\\%s.ini",buf,Name);
	if(-1 == OpenFile(IFile,&of,OF_EXIST))
		bNoConfigurationFile = TRUE;
		else
		bNoConfigurationFile = FALSE;
	hTheMenu 				= CreateMenu();
	strcpy(AdditionalInfo,"");
	GetPrivateProfileString(szApplication,"CreateIniDefaults","1",buf,MaxString,IFile);
	bCreateIniDefaults = atoi(buf);
	GetPrivateProfileString(szApplication,"User","Nutzer",User,MaxString,IFile);
	GetPrivateProfileString(szApplication,"Target","Probe",Target,MaxString,IFile);
	GetPrivateProfileString(szApplication,"Substrat","Si",TargetBulk,MaxString,IFile);
	GetPrivateProfileString(szApplication,"WaveLength","1.534",buf,MaxString,IFile);
	WaveLength = atof(buf);
	GetPrivateProfileString(szApplication,"Reflection","[001]",buf,10,IFile);
	SetHKL(Reflection,buf);
	GetPrivateProfileString(szApplication,"Orientation","[001]",buf,10,IFile);
	SetHKL(Orientation,buf);
	GetPrivateProfileString(szApplication,"Comment","",Comment,2*MaxString,IFile);
	Current = GetPrivateProfileInt(szApplication,"Current",10,IFile);
	Voltage = GetPrivateProfileInt(szApplication,"Voltage",20,IFile);
	bAutoCalibration = GetPrivateProfileInt(szApplication,"AutoCalibration",FALSE,IFile);
	bManualMovesCorrected = GetPrivateProfileInt("ManualMoves","Correction",FALSE,IFile);
	GetPrivateProfileString(szApplication,"Startup","Scan",buf,MaxString,IFile);
	while(1) {
		if(!strcmp(buf,"AreaScan"))
			{ Main.nStartup = 0; break;}
		if(!strcmp(buf,"Device"))
			{ Main.nStartup = 1; break;}
		if(!strcmp(buf,"Scan"))
			{	Main.nStartup = 2; break;}
		if(!strcmp(buf,"ManualAdjustment"))
			{ Main.nStartup = 3; break;}
		if(!strcmp(buf,"ScanPlace"))
			{ Main.nStartup = 4; break;}
		if(!strcmp(buf,"ExecuteMacro"))
			{ Main.nStartup = 5; break;}
		if(!strcmp(buf,"Nothing"))
			{ Main.nStartup = 6; break;}
		Main.nStartup = 2; break;
		}
	GetPrivateProfileString(szApplication,"Environment","RTK",buf,MaxString,IFile);
	while(1) {
		if(!strcmp(buf,"RTK"))
			{ WorkPlace = RTK; break;}
		if(!strcmp(buf,"HRM"))
			{ WorkPlace = HRM; break;}
		if(!strcmp(buf,"Expert"))
			{ WorkPlace = Expert; break;}
		if(!strcmp(buf,"ScanTable"))
			{ WorkPlace = ScanTable; break;}
		if(!strcmp(buf,"PDI-Diffractometer"))
			{ WorkPlace = PDI_Diffractometer; break;}
		if(!strcmp(buf,"Diff2"))
			{ WorkPlace = Diff2; break;}
		if(!strcmp(buf,"Diff3"))
			{ WorkPlace = Diff3; break;}
		WorkPlace = RTK; break;
		}
	switch(WorkPlace) {
		case HRM:
		AreaScanExtention = ScanExtention = 1;
		break;

		case RTK:
		ScanExtention = TopographyExtention = 1;
		break;

		case ScanTable:
		ScanTableExtention = 1;
		break;

		case PDI_Diffractometer:
		AreaScanExtention = ScanExtention = TopographyExtention = 1;
		break;

		case Diff2:
		AreaScanExtention = ScanExtention = TopographyExtention = 1;
		break;

		case Diff3:
		AreaScanExtention = ScanExtention = TopographyExtention = 1;
		break;

		case Expert:
		MacroExtention = AdjustmentExtention = AreaScanExtention = 1;
		ScanExtention = ScanTableExtention = TopographyExtention = 1;
		break;

		default:
		ScanExtention = TopographyExtention = 1;
		}
	};

TMain::~TMain(void)
	{
	SaveProfile();
	};

void TMain::SaveProfile(void)
	{
	char		buf[MaxString];
	RECT		rc;

	sprintf(buf,"%.3f",WaveLength);
	WritePrivateProfileString(szApplication,"WaveLength",buf,GetCFile());
	WritePrivateProfileString(szApplication,"User",User,GetCFile());
	WritePrivateProfileString(szApplication,"Target",Target,GetCFile());
	WritePrivateProfileString(szApplication,"Substrat",TargetBulk,GetCFile());
	GetHKL(Reflection,buf);
	WritePrivateProfileString(szApplication,"Reflection",buf,GetCFile());
	GetHKL(Orientation,buf);
	WritePrivateProfileString(szApplication,"Orientation",buf,GetCFile());
	WritePrivateProfileString(szApplication,"Comment",Comment,GetCFile());
	WritePrivateProfileString(szApplication,"Current",itoa(Current,buf,10),GetCFile());
	WritePrivateProfileString(szApplication,"Voltage",itoa(Voltage,buf,10),GetCFile());
	GetWindowRect(GetFrameHandle(),&rc);
	sprintf(buf,"%ld",min(max(0l,(long)rc.left),900l));
	WritePrivateProfileString(szApplication,"xo",buf,GetCFile());
	sprintf(buf,"%ld",min(max(0l,(long)rc.top),600l));
	WritePrivateProfileString(szApplication,"yo",buf,GetCFile());
	sprintf(buf,"%ld",min(max((long)rc.left + 100l,(long)rc.right),1000l));
	WritePrivateProfileString(szApplication,"x1",buf,GetCFile());
	sprintf(buf,"%ld",min(max((long)rc.top + 70l,(long)rc.bottom),750l));
	WritePrivateProfileString(szApplication,"y1",buf,GetCFile());
	};

void TMain::LoadProfile(void)
	{
	RECT		rc;

	rc.left 	= GetPrivateProfileInt(szApplication,"xo",500,GetCFile());
	rc.top  	= GetPrivateProfileInt(szApplication,"yo",400,GetCFile());
	rc.right	= GetPrivateProfileInt(szApplication,"x1",670,GetCFile());
	rc.bottom = GetPrivateProfileInt(szApplication,"y1",450,GetCFile());
	SetWindowPos(	GetFrameHandle(),NULL,rc.left,rc.top,rc.right - rc.left,
								rc.bottom - rc.top,SWP_NOZORDER);
	};

#ifdef GermanVersion
HMENU TMain::LoadMenuBar(void)
	{
	HMENU hmPL1,hmPL2;

	hTheMenu = CreateMenu();
	// Datei-Befehle
	hmPL1 = CreatePopupMenu();
	AppendMenu(hmPL1,MF_STRING,cm_New,"&Neu");
	AppendMenu(hmPL1,MF_STRING,cm_Open,"Nach&laden...");
	AppendMenu(hmPL1,MF_SEPARATOR,0,NULL);
	AppendMenu(hmPL1,MF_STRING,cm_Save,"&Sichern");
	AppendMenu(hmPL1,MF_STRING,cm_SaveAs,"Sichern &unter...");
	AppendMenu(hmPL1,MF_SEPARATOR,0,NULL);
	AppendMenu(hmPL1,MF_STRING,cm_Exit,"&Beenden");
	AppendMenu(hTheMenu,MF_POPUP,(WORD)hmPL1,"&Datei");

	// Bearbeiten
	hmPL1 = CreatePopupMenu();
	AppendMenu(hmPL1,MF_STRING,cm_Copy,"&Kopieren");
	AppendMenu(hTheMenu,MF_POPUP,(WORD)hmPL1,"&Bearbeiten");

	// ffnen
	hmPL1 = CreatePopupMenu();
	if(ScanExtention)
		AppendMenu(hmPL1,MF_STRING,cm_CallExecuteScan,"&Scan-Fenster");
	if(AreaScanExtention)
		AppendMenu(hmPL1,MF_STRING,cm_CallExecuteAreaScan,"&AreaScan-Fenster");
	if(AdjustmentExtention)
		AppendMenu(hmPL1,MF_STRING,cm_CallExecuteAdjustment,"&Justage-Fenster");
	if(ScanTableExtention)
		AppendMenu(hmPL1,MF_STRING,cm_CallExecuteCCDLineScan,"Scan-&Platz-Fenster");
#ifdef CCD_ExtentionOK
	AppendMenu(hmPL1,MF_STRING,cm_CallExecuteImageProc,"&ImageControl-Fenster");
#endif
	AppendMenu(hTheMenu,MF_POPUP,(WORD)hmPL1,"&ffnen");

	// Ausfhren
	hmPL1 = CreatePopupMenu();
	if(TopographyExtention)
		AppendMenu(hmPL1,MF_STRING,cm_CallExecuteTopograpy,"&Topographie...");
	hmPL2 = CreatePopupMenu();
	AppendMenu(hmPL1,MF_STRING,cm_AngleControl,"Manuelle &Justage...");
	if(MacroExtention)
		AppendMenu(hmPL1,MF_STRING,cm_CallExecuteMacro,"&Macro...");
	AppendMenu(hmPL1,MF_SEPARATOR,0,NULL);
	AppendMenu(hmPL1,MF_STRING,cm_InterruptAction,"Messung &unterbrechen");
	AppendMenu(hTheMenu,MF_POPUP,(WORD)hmPL1,"&Ausfhren");

	// Einstellungen
	hmPL1 = CreatePopupMenu();
	hmPL2 = CreatePopupMenu();
	AppendMenu(hmPL2,MF_STRING,cm_MotorParam,"&Parameter...");
	// AppendMenu(hmPL2,MF_STRING,cm_ExecuteCmd,(LPSTR)"&Terminal...");
	if(AdjustmentExtention)
		AppendMenu(hmPL2,MF_STRING,cm_PosControl,"&Direkte Steuerung...");
	EnableMenuItem(hmPL2,MF_BYCOMMAND,MF_GRAYED);
	AppendMenu(hmPL2,MF_SEPARATOR,0,NULL);
	AppendMenu(hmPL2,MF_STRING,cm_SetAngleDefault,"&Bereichsmaximierung");
	AppendMenu(hmPL2,MF_STRING,cm_Calibrate,"&Grundstellung...");
	AppendMenu(hmPL2,MF_STRING,cm_OptimizeDC,"&Optimieren...");
	AppendMenu(hmPL1,MF_POPUP,(WORD)hmPL2,"&Antriebe");
	if(AdjustmentExtention)
		AppendMenu(hmPL1,MF_STRING,cm_AdjustmentParam,"&Justage...");
	AppendMenu(hmPL1,MF_STRING,cm_MeasurementParam,"&Programm...");
	if(TopographyExtention)
		AppendMenu(hmPL1,MF_STRING,cm_TopograpyParam,"&Topographie...");
	hmPL2 = CreatePopupMenu();
	AppendMenu(hmPL2,MF_STRING,cm_SensorParam,"&Detektoren...");
#ifdef CCD_ExtentionOK
	AppendMenu(hmPL2,MF_STRING,cm_CCDParam,"&CCD-Kamera...");
	if(lpDList->MD_Matrox == -1)
		EnableMenuItem(hmPL2,MF_BYCOMMAND,MF_GRAYED);
#endif
	AppendMenu(hmPL1,MF_POPUP,(WORD)hmPL2,"&Detektoren");
	hmPL2 = CreatePopupMenu();
#ifdef CCD_ExtentionOK
	AppendMenu(hmPL2,MF_STRING,cm_MILInit,"&MIL Init");
	AppendMenu(hmPL2,MF_STRING,cm_ImageParam,"&FrameGrabber");
	AppendMenu(hmPL2,MF_STRING,cm_MatroxInit,"&Initialisieren");
	AppendMenu(hmPL1,MF_POPUP,(WORD)hmPL2,"Matro&x");
	if(lpDList->MD_Matrox == -1)
		EnableMenuItem(hmPL1,MF_BYCOMMAND,MF_GRAYED);
#endif
	AppendMenu(hTheMenu,MF_POPUP,(WORD)hmPL1,"&Einstellungen");

	// Fenster
	hmPL1 = CreatePopupMenu();
	AppendMenu(hmPL1,MF_STRING,cm_Cascade,(LPSTR)"&berlappend");
	AppendMenu(hmPL1,MF_STRING,cm_Tile,(LPSTR)"&Nebeneinander");
	AppendMenu(hmPL1,MF_STRING,cm_ArrangeIcons,(LPSTR)"&Symbole anordnen");
	AppendMenu(hTheMenu,MF_POPUP,(WORD)hmPL1,(LPSTR)"&Fenster");

	// Help
	hmPL1 = CreatePopupMenu();
	AppendMenu(hmPL1,MF_STRING,cm_H_Index,(LPSTR)"Hilfe Index");
	// AppendMenu(hmPL1,MF_STRING,cm_HelpHelp,(LPSTR)"&");
	AppendMenu(hTheMenu,MF_POPUP,(WORD)hmPL1,(LPSTR)"&Hilfe");
	AppendMenu(hmPL1,MF_SEPARATOR,0,NULL);
	AppendMenu(hmPL1,MF_STRING,cm_About,"&ber");

	SetMenu(Main.hWndFrame,hTheMenu);
	return NULL;
	};
#else
HMENU TMain::LoadMenuBar(void)
	{
	HMENU hmPL1,hmPL2;

	hTheMenu = CreateMenu();
	// Datei-Befehle
	hmPL1 = CreatePopupMenu();
	AppendMenu(hmPL1,MF_STRING,cm_New,"&New");
	AppendMenu(hmPL1,MF_STRING,cm_Open,"Re&load...");
	AppendMenu(hmPL1,MF_SEPARATOR,0,NULL);
	AppendMenu(hmPL1,MF_STRING,cm_Save,"&Save");
	AppendMenu(hmPL1,MF_STRING,cm_SaveAs,"Save &as...");
	AppendMenu(hmPL1,MF_SEPARATOR,0,NULL);
	AppendMenu(hmPL1,MF_STRING,cm_Exit,"E&xit");
	AppendMenu(hTheMenu,MF_POPUP,(WORD)hmPL1,"&File");

	// Bearbeiten
	hmPL1 = CreatePopupMenu();
	AppendMenu(hmPL1,MF_STRING,cm_Copy,"&Copy");
	AppendMenu(hTheMenu,MF_POPUP,(WORD)hmPL1,"&Edit");

	// ffnen
	hmPL1 = CreatePopupMenu();
	if(ScanExtention)
		AppendMenu(hmPL1,MF_STRING,cm_CallExecuteScan,"&Scan-Window");
	if(AreaScanExtention)
		AppendMenu(hmPL1,MF_STRING,cm_CallExecuteAreaScan,"&AreaScan-Window");
	if(AdjustmentExtention)
		AppendMenu(hmPL1,MF_STRING,cm_CallExecuteAdjustment,"&Adjustment-Window");
	if(ScanTableExtention)
		AppendMenu(hmPL1,MF_STRING,cm_CallExecuteCCDLineScan,"Scan&Place-Window");
	AppendMenu(hTheMenu,MF_POPUP,(WORD)hmPL1,"&Open");

	// Ausfhren
	hmPL1 = CreatePopupMenu();
	if(TopographyExtention)
		AppendMenu(hmPL1,MF_STRING,cm_CallExecuteTopograpy,"&Topography...");
	hmPL2 = CreatePopupMenu();
	AppendMenu(hmPL1,MF_STRING,cm_AngleControl,"Manual &Adjustment...");
	if(MacroExtention)
		AppendMenu(hmPL1,MF_STRING,cm_CallExecuteMacro,"&Macro...");
	AppendMenu(hmPL1,MF_SEPARATOR,0,NULL);
	AppendMenu(hmPL1,MF_STRING,cm_InterruptAction,"&Interrupt Measurement");
	AppendMenu(hTheMenu,MF_POPUP,(WORD)hmPL1,"&Execute");

	// Einstellungen
	hmPL1 = CreatePopupMenu();
	hmPL2 = CreatePopupMenu();
	AppendMenu(hmPL2,MF_STRING,cm_MotorParam,"&Parameters...");
	if(AdjustmentExtention)
		AppendMenu(hmPL2,MF_STRING,cm_PosControl,"&Direct Steering...");
	EnableMenuItem(hmPL2,MF_BYCOMMAND,MF_GRAYED);
	AppendMenu(hmPL2,MF_SEPARATOR,0,NULL);
	AppendMenu(hmPL2,MF_STRING,cm_SetAngleDefault,"&Expand Range");
	AppendMenu(hmPL2,MF_STRING,cm_Calibrate,"&Reference Points...");
	AppendMenu(hmPL2,MF_STRING,cm_OptimizeDC,"&Optimize Drive...");
	AppendMenu(hmPL1,MF_POPUP,(WORD)hmPL2,"&Motors");
	if(AdjustmentExtention)
		AppendMenu(hmPL1,MF_STRING,cm_AdjustmentParam,"&Adjustment...");
	AppendMenu(hmPL1,MF_STRING,cm_MeasurementParam,"&Program...");
	if(TopographyExtention)
		AppendMenu(hmPL1,MF_STRING,cm_TopograpyParam,"&Topography...");
	hmPL2 = CreatePopupMenu();
	AppendMenu(hmPL2,MF_STRING,cm_SensorParam,"&Devices...");
	AppendMenu(hmPL1,MF_POPUP,(WORD)hmPL2,"&Detectors");
	hmPL2 = CreatePopupMenu();
	AppendMenu(hTheMenu,MF_POPUP,(WORD)hmPL1,"&Settings");

	// Fenster
	hmPL1 = CreatePopupMenu();
	AppendMenu(hmPL1,MF_STRING,cm_Cascade,(LPSTR)"&Cascade");
	AppendMenu(hmPL1,MF_STRING,cm_Tile,(LPSTR)"&Tile");
	AppendMenu(hmPL1,MF_STRING,cm_ArrangeIcons,(LPSTR)"Arrange &Icons");
	AppendMenu(hTheMenu,MF_POPUP,(WORD)hmPL1,(LPSTR)"&Window");

	// Help
	hmPL1 = CreatePopupMenu();
	AppendMenu(hmPL1,MF_STRING,cm_H_Index,(LPSTR)"&Index");
	// AppendMenu(hmPL1,MF_STRING,cm_HelpHelp,(LPSTR)"&");
	AppendMenu(hTheMenu,MF_POPUP,(WORD)hmPL1,(LPSTR)"&Help");
	AppendMenu(hmPL1,MF_SEPARATOR,0,NULL);
	AppendMenu(hmPL1,MF_STRING,cm_About,"&About");
	SetMenu(Main.hWndFrame,hTheMenu);
	return NULL;
	};
#endif

void TMain::TellMessage(int ret)
	{
	switch(ret){
	 case R_NoWindow:
	 MessageBox(hWndFrame,strMessage12,strMessage,MBINFO);
	 break;
	 case R_Failure:
	 MessageBox(hWndFrame,strMessage15,strMessage,MBINFO);
	 break;
	 case R_Stopped:
	 MessageBox(GetFocus(),strMessage13,strMessage,MBINFO);
	 break;
	 }
  };

void TMain::SetWatchIndicator(long st)
	{
	HDC       memDC,hDC;
	RECT      cRect;
	HANDLE    oldBmp;
	RECT      Rect;
	LOGFONT   lf;
	HFONT     hSmall,hOld;
	SIZE      size;

	hDC = GetDC(hWndFrame);
	// Zeichnen der aktuellen StatusInformation
	GetClientRect(hWndFrame,&cRect);
	memDC  = CreateCompatibleDC(hDC);
	// Fail by stop program
	if(!bShutdown)
		oldBmp = SelectObject(memDC,Main.bmpStatusLine);
	retval = BitBlt( hDC,WatchStart,cRect.bottom-StatusLineHeight,TargetStart-WatchStart, \
										StatusLineHeight,memDC,0,0,SRCCOPY);
	// Fail by stop program
	if(!bShutdown)
		testobc = SelectObject(memDC,Main.bmpStatusLine);
	retval = BitBlt( hDC,WatchStart,cRect.bottom-StatusLineHeight,TargetStart-WatchStart, \
										StatusLineHeight,memDC,0,0,SRCCOPY);
	// Fail by stop program
	if(!bShutdown)
		testobc = SelectObject(memDC,oldBmp);
	// get a slightly smaller font
	hOld = (HFONT)GetStockObject(ANSI_VAR_FONT);
	if(hOld)
		{
		GetObject(hOld,sizeof(LOGFONT),(LPSTR)&lf);
		lf.lfWidth = 0;
		hSmall = CreateFontIndirect( &lf);
		}
		else
		hSmall = 0;
	if(hSmall)
		hOld = (HFONT)SelectObject(hDC,(HFONT)hSmall);
		else
		hOld = 0;
	GetClientRect(hWndFrame,&Rect);
	SetBkColor(hDC,RGB(192,192,192));
	GetTextExtentPoint(hDC,StatusInfo,1,&size);
	// Ausgabe der aktuellen Probe
	switch(st % 4) {
		case 0:
		TextOut(hDC,4,Rect.bottom-StatusLineHeight+((StatusLineHeight-size.cy)/2),"\\",1);
		break;
		case 1:
		TextOut(hDC,4,Rect.bottom-StatusLineHeight+((StatusLineHeight-size.cy)/2),"|",1);
		break;
		case 2:
		TextOut(hDC,4,Rect.bottom-StatusLineHeight+((StatusLineHeight-size.cy)/2),"/",1);
		break;
		case 3:
		TextOut(hDC,4,Rect.bottom-StatusLineHeight+((StatusLineHeight-size.cy)/2),"-",1);
		break;
		}
	if(hOld)
		testobc = SelectObject(hDC,hOld);
	if(hSmall) DeleteObject(hSmall);
	DeleteDC(memDC);
	ReleaseDC(hWndFrame,hDC);
	};

void TMain::SetParameters(void)
	{
	Parameters.hWndFrame 					= hWndFrame;
	Parameters.hWndClient					= hWndClient;
	Parameters.hInstance					= hInstance;
	Parameters.wm_DrawStatus			= wm_DrawStatus;
	Parameters.bCreateIniDefaults = bCreateIniDefaults;
	strcpy(Parameters.IniFile,IFile);
	};

//******************************************************************************
//****** Allgemeine Schnittstelle fr Anwenderfenster **************************
//******************************************************************************
void NewWindow(TMDIWindow* window)
	{
	MDICREATESTRUCT   mdiCreate;

	mdiCreate.szClass   = (LPSTR)window->ClassName();
	mdiCreate.szTitle   = (LPSTR)window->Title;
	mdiCreate.hOwner    = Main.hInstance;
	mdiCreate.x         = CW_USEDEFAULT;
	mdiCreate.y         = CW_USEDEFAULT;
	mdiCreate.cx        = CW_USEDEFAULT;
	mdiCreate.cy        = CW_USEDEFAULT;
	mdiCreate.style     = 0;
	mdiCreate.lParam    = NULL;
	Main.CurrentWindow  = window;
	SendMessage((HWND)Main.hWndClient,WM_MDICREATE,NULL, \
							(LONG)(LPMDICREATESTRUCT)&mdiCreate);
	};

TMDIWindow::TMDIWindow()
	{
	strcpy(Title,ClassName());
	TMDIWindow::WindowId++;
	bIsNewFile     = TRUE;
	bFileChanged   = FALSE;
	bOldDataLoaded = FALSE;
	strcpy(FileName,"*.wnd");
	bInterrupted   = FALSE;
	bPaintPoint    = FALSE;
	bMeasurementActive = FALSE;
	};

TMDIWindow::~TMDIWindow()
	{
	WindowId--;
	};

BOOL TMDIWindow::New(void)
	{
	bFileChanged   = FALSE;
	bInterrupted   = FALSE;
	bPaintPoint    = FALSE;
	bOldDataLoaded = FALSE;
	bMeasurementActive = FALSE;
	UpdateWnd(0);
	return TRUE;
	};

WORD TMDIWindow::RegisterWnd(void)
	{
	WNDCLASS   wndClass,wndAsk;

	GetWindowClass(&wndClass);
	if(!GetClassInfo(wndClass.hInstance,wndClass.lpszClassName,&wndAsk))
		return (RegisterClass(&wndClass));
		else
		return NULL;
	};

void TMDIWindow::GetWindowClass(WNDCLASS *wndClass)
	{
	wndClass->style         = CS_HREDRAW | CS_VREDRAW;
	wndClass->cbClsExtra    = 0;
	wndClass->cbWndExtra    = 8;
	wndClass->hInstance     = Main.hInstance;
	wndClass->hIcon         = LoadIcon(NULL,IDI_APPLICATION);
	wndClass->hCursor       = GetCursor();
	wndClass->hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
	wndClass->lpszMenuName  = "";
	wndClass->lpszClassName = (LPSTR)ClassName();
	switch(WindowType) {
		default:
		wndClass->lpfnWndProc   = WndProc;
		}
	};

BOOL TMDIWindow::SaveFile(int task)
	{
	char    		NewFileName[MAXPATH];
	char    		dir[MAXDIR],drv[MAXDRIVE],name[MAXFILE],ext[MAXEXT];
	OFSTRUCT   	of;
	int					nNumber = 0,hFile;
	HFILE				ht;

	ht = _lopen("test",READ_WRITE);
	_lclose(ht);
	chdir(szDataPath);
	switch(task) {
		case NoAskForSave:
		// Test ob File beschrieben werden kann
		fnsplit(FileName,drv,dir,name,ext);
		fnmerge(NewFileName,"","",name,szExtension);
		hFile = OpenFile(NewFileName,&of,OF_CREATE);
		if(HFILE_ERROR == hFile)
			do
				{
				sprintf(NewFileName,"%sscan%03d.%s",szDataPath,nNumber++,szExtension);
				hFile = OpenFile(NewFileName,&of,OF_EXIST);
				}
			while(HFILE_ERROR != hFile);
		_lclose(hFile);
		break;

		case SaveWithNewName:
		sprintf(NewFileName,"*.%s",szExtension);
		if(!FileSave("Sichern unter ...",szFilter,NewFileName,szDataPath))
			{
			// FileSave() wurde abgebrochen
			return FALSE;
			}
		break;

		default:
		if(!bFileChanged)
			{
			SetInfo(strMessage14);
			return FALSE;
			}
		if(bIsNewFile)
			sprintf(NewFileName,"*.%s",szExtension);
			else
			{
			fnsplit(FileName,drv,dir,name,ext);
			fnmerge(NewFileName,"","",name,szExtension);
			}
		if(!FileSave("Sichern als ...",szFilter,NewFileName,szDataPath))
			{
			// FileSave() wurde abgebrochen
			return FALSE;
			}
		}
	fnsplit(NewFileName,drv,dir,name,ext);
	fnmerge(FileName,drv,dir,name,szExtension);
	bIsNewFile   = FALSE;
	bOldDataLoaded = FALSE;
	bFileChanged = FALSE;
	chdir(szDataPath);
	SetTitle();
	return TRUE;
	};

BOOL TMDIWindow::SaveFileAs(void)
	{
	char      Old_FileName[MAXPATH];
	BOOL      Old_bFileChanged = bFileChanged;
	BOOL      Old_bIsNewFile = bIsNewFile;

	strcpy(Old_FileName,FileName);
	bFileChanged = TRUE;
	bIsNewFile = TRUE;
	strcpy(FileName,"");
	if(SaveFile(SaveWithNewName))
		return TRUE;
	strcpy(FileName,Old_FileName);
	bIsNewFile = Old_bIsNewFile;
	return FALSE;
	};

BOOL TMDIWindow::CanOpen(void)
	{
	if(TMDIWindow::WindowId > 5)
		{
		MessageBox(GetFocus(),strMessage02,strFailure,MB_OK);
		return FALSE;
		}
		else
		return TRUE;
	};

BOOL TMDIWindow::CanClose(void)
	{
	if(WindowId < 0) return FALSE;
	if(bMeasurementActive && !bInterrupted)
		Interrupt();
	if(bFileChanged)
		{
		switch(MessageBox(hWndChild,strMessage03,strMessage,MBASK)) {
			case IDYES:
			SaveFile(0);
			return TRUE;
			}
		}
	return TRUE;
	};

void TMDIWindow::UpdateWnd(int act)
	{
	switch(act) {
		case O_PaintPoint:
		bPaintPoint = TRUE;
		SetTitle();
		InvalidateRect(hWndChild,NULL,!bPaintPoint);
		break;

		case O_Flush:
		{
		PAINTSTRUCT ps;
		HDC hdc = BeginPaint(hWndChild,&ps);
		Paint(hdc,&ps);
		EndPaint(hWndChild,&ps);
		}
		break;

		default:
		SetTitle();
		InvalidateRect(hWndChild,NULL,!bPaintPoint);
		}
	};

BOOL TMDIWindow::WholeWnd(void)
	{
	int b = bPaintPoint;
	bPaintPoint = FALSE;
	return !b;
	};

void  TMDIWindow::SetFocus(void)
	{
	Main.CurrentWindow = this;
	};

void  TMDIWindow::UpdateMenu(void)
	{
	HMENU hMenu;

	hMenu = GetMenu(Main.hWndFrame);
	if(bInterrupted)
		ModifyMenu( hMenu,cm_InterruptAction,MF_BYCOMMAND,cm_InterruptAction,strMessage04);
		else
		ModifyMenu( hMenu,cm_InterruptAction,MF_BYCOMMAND,cm_InterruptAction,strMessage05);
	DrawMenuBar(Main.hWndFrame);
	};

BOOL TMDIWindow::SetFileName(LPSTR fn)
	{
	if(strstr("\\",fn))
		sprintf(FileName,"%s",fn);
		else
		sprintf(FileName,"%s%s",szDataPath,fn);
	bIsNewFile = (0 == strlen(FileName));
	return TRUE;
	};

void TMDIWindow::Interrupt()
	{
	if(!bMeasurementActive) return;
	bInterrupted = !bInterrupted;
	UpdateMenu();
	};
//******************************************************************************
// __LastLine__

